    ###############Install MIM PAM Functions#############
#===========================================================
#Install Functions
#===========================================================
Function InstallMIMWithPAM
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Validating whether or not PAM is already installed on the target server"
    if (IsMIMPAMinstalled)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "MIM with PAM already installed"
    }
    else
    {

        If ($env:COMPUTERNAME -eq $env:USERDOMAIN)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "You are running this script under a local machine user account. You must be a domain user - script aborting"
            throw
        }

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Getting all credential info"
        Get-PAMUserCredentials $MIMRole

        $password

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Preparing the setup parameters..."        
        $ArgumentList="/i `"$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME`" SQMOPTINSETTING=`"$SQMOPTINSETTING`"  SQLSERVER_SERVER=`"$SQLSERVER_SERVER`" SERVICE_ACCOUNT_NAME=`"$PAM_SERVICE_ACCOUNT_NAME`" SERVICE_ACCOUNT_PASSWORD=`"$PAM_SERVICE_ACCOUNT_PASSWORD`" SERVICE_ACCOUNT_DOMAIN=`"$Domain`" SERVICE_ACCOUNT_EMAIL=`"$PAM_SERVICE_ACCOUNT_NAME@$DomainFQDN`" RUNNING_USER_EMAIL=`"$AdminAccount@$DomainFQDN`" SYNCHRONIZATION_SERVER_ACCOUNT=`"$Domain\$SYNC_ADMIN_ACCOUNT_NAME`" SYNCHRONIZATION_SERVER=`"`" SERVICEADDRESS=`"$ServerName`" SHAREPOINTUSERS_CONF=`"$SHAREPOINTUSERS_CONF`" REGISTRATION_PORTAL_URL=`"$REGISTRATION_PORTAL_URL`" SHAREPOINT_URL=`"$SHAREPOINT_URL`" ADDLOCAL=`"$FEATURES_TO_INSTALL`" PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN=$PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN PAM_MONITORING_SERVICE_ACCOUNT_NAME=$PAM_MONITORING_SERVICE_ACCOUNT_NAME PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD=$PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN=$PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN PAM_COMPONENT_SERVICE_ACCOUNT_NAME=$PAM_COMPONENT_SERVICE_ACCOUNT_NAME PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD=$PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN=$PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN PAM_REST_API_APPPOOL_ACCOUNT_NAME=$PAM_REST_API_APPPOOL_ACCOUNT_NAME PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD=$PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD MAIL_SERVER=`"$MAIL_SERVER`" MAIL_SERVER_USE_SSL=0 MAIL_SERVER_IS_EXCHANGE=0 ACCEPT_EULA=$ACCEPT_EULA MIMPAM_REST_API_PORT=$MIMPAM_REST_API_PORT FIREWALL_CONF=$FIREWALL_CONF REBOOT=`"$REBOOT`" /l*v `"$LOGFILENAME`" /qn" 
        #$ArgumentList="/i `"$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME`" SQMOPTINSETTING=`"$SQMOPTINSETTING`"  SQLSERVER_SERVER=`"$SQLSERVER_SERVER`" SERVICE_ACCOUNT_NAME=`"$PAM_SERVICE_ACCOUNT_NAME`" SERVICE_ACCOUNT_PASSWORD=`"$PAM_SERVICE_ACCOUNT_PASSWORD`" SERVICE_ACCOUNT_DOMAIN=`"$Domain`" SERVICE_ACCOUNT_EMAIL=`"$PAM_SERVICE_ACCOUNT_NAME@$DomainFQDN`" RUNNING_USER_EMAIL=`"$AdminAccount@$DomainFQDN`" SYNCHRONIZATION_SERVER_ACCOUNT=`"$Domain\$SYNC_ADMIN_ACCOUNT_NAME`" SYNCHRONIZATION_SERVER=`"`" SERVICEADDRESS=`"$ServerName`" SHAREPOINTUSERS_CONF=`"$SHAREPOINTUSERS_CONF`" REGISTRATION_PORTAL_URL=`"$REGISTRATION_PORTAL_URL`" SHAREPOINT_URL=`"$SHAREPOINT_URL`" ADDLOCAL=`"$FEATURES_TO_INSTALL`" PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN=$PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN PAM_MONITORING_SERVICE_ACCOUNT_NAME=$PAM_MONITORING_SERVICE_ACCOUNT_NAME PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD=$PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN=$PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN PAM_COMPONENT_SERVICE_ACCOUNT_NAME=$PAM_COMPONENT_SERVICE_ACCOUNT_NAME PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD=$PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN=$PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN PAM_REST_API_APPPOOL_ACCOUNT_NAME=$PAM_REST_API_APPPOOL_ACCOUNT_NAME PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD=$PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD MAIL_SERVER=`"$MAIL_SERVER`" MAIL_SERVER_USE_SSL=0 MAIL_SERVER_IS_EXCHANGE=0 ACCEPT_EULA=$ACCEPT_EULA MIMPAM_REST_API_PORT=$MIMPAM_REST_API_PORT FIREWALL_CONF=$FIREWALL_CONF REBOOT=`"$REBOOT`" /l*v `"$LOGFILENAME`"" 
       
        $passwordChars = "********"
        $ArgumentListToPrint="/i `"$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME`" SQMOPTINSETTING=`"$SQMOPTINSETTING`"  SQLSERVER_SERVER=`"$SQLSERVER_SERVER`" SERVICE_ACCOUNT_NAME=`"$PAM_SERVICE_ACCOUNT_NAME`" SERVICE_ACCOUNT_PASSWORD=`"$passwordChars`" SERVICE_ACCOUNT_DOMAIN=`"$Domain`" SERVICE_ACCOUNT_EMAIL=`"$PAM_SERVICE_ACCOUNT_NAME@$DomainFQDN`" RUNNING_USER_EMAIL=`"$AdminAccount@$DomainFQDN`" SYNCHRONIZATION_SERVER_ACCOUNT=`"$Domain\$SYNC_ADMIN_ACCOUNT_NAME`" SYNCHRONIZATION_SERVER=`"`" SERVICEADDRESS=`"$ServerName`" SHAREPOINTUSERS_CONF=`"$SHAREPOINTUSERS_CONF`" REGISTRATION_PORTAL_URL=`"$REGISTRATION_PORTAL_URL`" SHAREPOINT_URL=`"$SHAREPOINT_URL`" ADDLOCAL=`"$FEATURES_TO_INSTALL`" PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN=$PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN PAM_MONITORING_SERVICE_ACCOUNT_NAME=$PAM_MONITORING_SERVICE_ACCOUNT_NAME PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD=$passwordChars PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN=$PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN PAM_COMPONENT_SERVICE_ACCOUNT_NAME=$PAM_COMPONENT_SERVICE_ACCOUNT_NAME PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD=$passwordChars PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN=$PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN PAM_REST_API_APPPOOL_ACCOUNT_NAME=$PAM_REST_API_APPPOOL_ACCOUNT_NAME PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD=$passwordChars MAIL_SERVER=`"$MAIL_SERVER`" MAIL_SERVER_USE_SSL=0 MAIL_SERVER_IS_EXCHANGE=0 ACCEPT_EULA=$ACCEPT_EULA MIMPAM_REST_API_PORT=$MIMPAM_REST_API_PORT FIREWALL_CONF=$FIREWALL_CONF REBOOT=`"$REBOOT`" /l*v `"$LOGFILENAME`" /qn" 
        #$ArgumentListToPrint="/i `"$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME`" SQMOPTINSETTING=`"$SQMOPTINSETTING`"  SQLSERVER_SERVER=`"$SQLSERVER_SERVER`" SERVICE_ACCOUNT_NAME=`"$PAM_SERVICE_ACCOUNT_NAME`" SERVICE_ACCOUNT_PASSWORD=`"$passwordChars`" SERVICE_ACCOUNT_DOMAIN=`"$Domain`" SERVICE_ACCOUNT_EMAIL=`"$PAM_SERVICE_ACCOUNT_NAME@$DomainFQDN`" RUNNING_USER_EMAIL=`"$AdminAccount@$DomainFQDN`" SYNCHRONIZATION_SERVER_ACCOUNT=`"$Domain\$SYNC_ADMIN_ACCOUNT_NAME`" SYNCHRONIZATION_SERVER=`"`" SERVICEADDRESS=`"$ServerName`" SHAREPOINTUSERS_CONF=`"$SHAREPOINTUSERS_CONF`" REGISTRATION_PORTAL_URL=`"$REGISTRATION_PORTAL_URL`" SHAREPOINT_URL=`"$SHAREPOINT_URL`" ADDLOCAL=`"$FEATURES_TO_INSTALL`" PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN=$PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN PAM_MONITORING_SERVICE_ACCOUNT_NAME=$PAM_MONITORING_SERVICE_ACCOUNT_NAME PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD=$passwordChars PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN=$PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN PAM_COMPONENT_SERVICE_ACCOUNT_NAME=$PAM_COMPONENT_SERVICE_ACCOUNT_NAME PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD=$passwordChars PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN=$PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN PAM_REST_API_APPPOOL_ACCOUNT_NAME=$PAM_REST_API_APPPOOL_ACCOUNT_NAME PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD=$passwordChars MAIL_SERVER=`"$MAIL_SERVER`" MAIL_SERVER_USE_SSL=0 MAIL_SERVER_IS_EXCHANGE=0 ACCEPT_EULA=$ACCEPT_EULA MIMPAM_REST_API_PORT=$MIMPAM_REST_API_PORT FIREWALL_CONF=$FIREWALL_CONF REBOOT=`"$REBOOT`" /l*v `"$LOGFILENAME`" /qn" 

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Installing PAM using MSIExec.exe with arguments -> $ArgumentListToPrint" 
        $p=Start-Process "MSIEXEC.EXE" -ArgumentList "$ArgumentList" -PassThru -Wait

        $exitCode = $p.ExitCode # = executeProcess -command "MSIEXEC.EXE" -arguments "$ArgumentList"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Process completed with Exit code -> $exitCode.  Please check the log file $LOGFILENAME for more information." 
                
        if ($exitCode -ne 3010)
        {
            if ($exitCode -eq 1602)
            {
                throw "Install aborted by the user"
            }
            else
            {
                throw "Install of MIM returned with exit code $ExitCode"
            }
        }
        
        If ((Test-Path -Path "$LOGFILENAME") -eq $False)
        {
            Write-Warning "Could not find MIM log file '$LOGFILENAME' "
        }
        Else
        {
            # Look for restart requirement in log
            $LogFile = Get-ChildItem -Path "$LOGFILENAME"
            $RestartNeeded = ($LogFile | Select-String -SimpleMatch -Pattern "Microsoft Identity Manager Service and Portal. Restart required" -Encoding Unicode) 
            If ($RestartNeeded)
            {
                SetRestartRequired
                throw " - Restart for setup required"
            }
            else
            {
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "No restart for setup required."
            }
        }
    }
  
}

Function RemoveMIMWithPAM
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Validating whether or not PAM is already installed on the target server"
    if (IsMIMPAMinstalled)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "MIM with PAM installed.  Uninstalling it."

        $ArgumentList="/uninstall `"$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME`" /qn" 

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "UnInstalling PAM using MSIExec.exe with arguments -> " + $ArgumentList
        $p=Start-Process "MSIEXEC.EXE" -ArgumentList "$ArgumentList" -PassThru -Wait
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "MIM with PAM not installed on server."
    }
  
}

Function Configure-LocalSecurityPolicy
{
    Param
    (
        [string] $accountToAdd,
        [string] $privilegeRight
    )

    $message = "Configure-LocalSecurityPolicy - Started"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

    $sidAccountToAdd = $null
    try 
    {
        $message = "Getting SID details for given account " + $accountToAdd
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

        $ntprincipal = new-object System.Security.Principal.NTAccount "$accountToAdd"
        $sid = $ntprincipal.Translate([System.Security.Principal.SecurityIdentifier])
        $sidAccountToAdd = $sid.Value.ToString()
    } 
    catch 
    {
        $sidAccountToAdd = $null
    }

    if( [string]::IsNullOrEmpty($sidAccountToAdd) )
    {        
        $message = "Account not found!" + $accountToAdd
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  $message
        throw
    }

    
    $message = "Account SID: $($sidAccountToAdd)"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

    $tmp = [System.IO.Path]::GetTempFileName()

    
    $message = "Exporting the current Local Security Policy"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    
    secedit.exe /export /cfg "$($tmp)" 

    $content = Get-Content -Path $tmp 

    $currentSetting = ""


    foreach($str in $content) 
    {
        if( $str -like "$privilegeRight*") 
        {
            $splitStr = $str.split("=",[System.StringSplitOptions]::RemoveEmptyEntries)
            $currentSetting = $splitStr[1].Trim()
        }
    }

    if( $currentSetting -notlike "*$($sidAccountToAdd)*" ) 
    {
        $message = "Updating the settings to add account sid"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    
        if( [string]::IsNullOrEmpty($currentSetting) ) {
            $currentSetting = "*$($sidAccountToAdd)"
        } else {
            $currentSetting = "*$($sidAccountToAdd),$($currentSetting)"
        }
            
        $message = "Current Settings - $currentSetting"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    
        $outfile = @"
[Unicode]
Unicode=yes
[Version]
signature="`$CHICAGO`$"
Revision=1
[Privilege Rights]
$privilegeRight = $($currentSetting)
"@

        $tmp2 = [System.IO.Path]::GetTempFileName()    
    
        Write-Host "Import new settings to Local Security Policy" -ForegroundColor DarkCyan
        $message = "Import new settings to Local Security Policy"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

        $outfile | Set-Content -Path $tmp2 -Encoding Unicode -Force

        Push-Location (Split-Path $tmp2)
    
        try 
        {
            secedit.exe /configure /db "secedit.sdb" /cfg "$($tmp2)" /areas USER_RIGHTS             
        } 
        finally 
        {    
            Pop-Location
        }
    } 
    else 
    {        
        $message = "No Action Required! Account already in " + $privilegeRight
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    }

    $message = "Configure-LocalSecurityPolicy - Completed"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
}

#===========================================================
#Test and Support Functions
#===========================================================
Function StartSQLServerAgent($ServerName)
{
    
    $ManagedSQLcomputer = new-object Microsoft.SqlServer.Management.Smo.Wmi.ManagedComputer $ServerName
    $SQLagent = $ManagedSQLcomputer.Services['SQLSERVERAGENT']

    if($SQLagent -eq "")
    {
        $Message = "SQL Server Agent service does not exist in the server - " + $ServerName
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  $Message
        throw $Message
    }

    if ($SQLagent.ServiceState -eq "Stopped")
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Starting SQL Server Agent..."
        $SQLagent.Start()
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Started SQL Server Agent"
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SQL Server Agent is already running"
    }
}

Function TestForFireWallRule($RuleName)
{
    if ((Get-NetFirewallRule -DisplayName $RuleName -ErrorAction Ignore) -eq $NUll)
    {
        throw "Fire wall rule missing! - $RuleName"
    }
}

Function TestForFireWallRules
{
    TestForFireWallRule -RuleName "Forefront Identity Manager Service (STS)"
    TestForFireWallRule -RuleName "Forefront Identity Manager Service (Webservice)"
}

Function CheckNetworkSettings
{
    TestForFireWallRules

    #Now create the new one, if it does not exist

    $RuleName="MIM-PAM extra ports"

    #Remove-NetFirewallRule -DisplayName $RuleName

    $FireWallRule = Get-NetFirewallRule -DisplayName $RuleName -ErrorAction Ignore

    if ($FireWallRule -eq $null)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Creating FireWall rule $RuleName"
    
        New-NetFirewallRule -DisplayName $RuleName -Description "Enable inbound TCP from 8086, 8090" -Enabled True -Profile "Any" -Direction Inbound -Action Allow -EdgeTraversalPolicy Block -Protocol TCP -LocalPort 8086, 8090
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Fire wall $RuleName exists, skipping create"
    }
    ##ManualStep -Message "Need to check for active network here - open Network Sharing Center and check that our domain exists and is marked as a Domain Network"
}

Function OurRegistryNode
{
    return "HKLM:\SOFTWARE\$OurRegistryLocation\"
}

Function IsRestartRequired
{    
    $Path = OurRegistryNode 
    $RegistryNode=get-item -Path "$Path" -ErrorAction SilentlyContinue
    if ($RegistryNode -eq $null)
    {
        return $False
    }

    $item = get-itemproperty -Path "$path" -ErrorAction SilentlyContinue
    return $item.$RestartRegistryName -eq 1
}

Function ClearRestartRequired
{
    $Path = OurRegistryNode 
    Remove-ItemProperty -Path "$path" -Name "$RestartRegistryName" -ErrorAction SilentlyContinue
}

Function SetRestartRequired
{
    $Path = OurRegistryNode 
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Setting Restart Required in the registry..."
    New-Item -Path "$Path" -ErrorAction SilentlyContinue | Out-Null
    $regKey = Get-Item -Path "$Path"
    $regKey | New-ItemProperty -Name "$RestartRegistryName" -PropertyType String -Value "1" -Force | Out-Null
}

Function RemoveRegistrySettings
{
    $path="HKLM:\SOFTWARE\$OurRegistryLocation\"
    if (-not (Test-Path -Path "$path"))
    {
        New-Item -Path "$path" -ErrorAction SilentlyContinue | Out-Null
    }

     ClearRestartRequired
}

Function IsMIMPAMinstalled
{
    #Crude test, check if the MIM/PAM files exist
    $FileToTest="$MIMInstalledRoot\Service\Microsoft.ResourceManagement.Service.exe"

    if (test-path -Path "$FileToTest")
    {
        Return $True
    }
    else
    {
        Return $False
    }
}

Function ManualStep($Message)
{
    Write-Host -ForegroundColor yellow "Manual step because there is no know good PowerShell solution: $Message"
    Pause
}


Function CreatePAMportal
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Copying PAM Portal site ($PAMPortalDirectory) to PAM folder ($PAMDestinationDirectory)"

    if (test-path -Path "$PAMDestinationDirectory")
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "PAM portal folder already exists, if you think that all files have not been copied, then delete the destination folder ($MIMInstalledRoot) and re-run the script" 
    }
    else
    {
        copy-item "$PAMPortalDirectory" "$MIMInstalledRoot" -Recurse
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Files copied"
    }

    
    $SiteName="MIM Privileged Access Management Portal"

    $Site=Get-Website -Name "$SiteName" -ErrorAction Ignore
    if ($site -eq $null)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Creating PAM Web Site '$SiteName' port '8090' from '$PAMDestinationDirectory'"
        New-WebSite -Name "$SiteName" -Port 8090  -PhysicalPath "$PAMDestinationDirectory"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Site created"
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Site exists '$SiteName'"
    }
}

Function CheckFile($File, $msg)
{
    if (-not(Test-Path -Path "$File"))
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "'$File' does not exist.  Aborting the installation"
        throw "Missing file $File; $msg - install aborted"
    }   
}

Function CheckFiles
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Checking required installer files exist in $MIMPAMServerMSILOCATION"
    CheckFile -File "$MIMPAMServerMSILOCATION" -msg "Expand the files to this location"
    
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Checking required installer files exist in $MIMPAMServerMSILOCATION\$MIMPAMServerMSIFileName"
    CheckFile -File "$MIMPAMServerMSILOCATION\$MIMPAMServerMSIFILENAME" -msg "Expand the files to this location"

    #Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Checking required installer files exists $PAMPortalDirectory"
    #CheckFile -File "$PAMPortalDirectory" -msg "Expand the files to this location"
}

Function CreateXMLElementWithAttributes([xml]$xml, $attributeName, $attributeValue)
{
    $node=$xml.CreateElement('add')

    $node.SetAttribute('value', $attributeValue)
    $node.SetAttribute('name',$attributeName)

    return $node
}


Function UpdatePAMRestAPIconfigXML
{
    #In <system.webServer>, add
    #<httpProtocol> 
    #       <customHeaders> 
    #<add name="Access-Control-Allow-Credentials" value="true"  /> 
    #<add name="Access-Control-Allow-Headers" value="content-type" /> 
    #<add name="Access-Control-Allow-Origin" value="http://pamsrv:8090" />  
    #       </customHeaders> 
    #</httpProtocol>

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Adding XML section to '$PAMRestAPIWebConfig'"
    if (test-path -Path "$PAMRestAPIWebConfig")
    {
        $xml = New-Object XML
        $xml = [xml](Get-Content $PAMRestAPIWebConfig)
        $configurationGroup=$xml.SelectSingleNode('configuration') #Root node of document
        $systemWebServerGroup=$configurationGroup.SelectSingleNode('system.webServer')

        $httpProtocolGroup = $systemWebServerGroup.SelectSingleNode('httpProtocol')
        if ($httpProtocolGroup -ne $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "<httpProtocol> node already exists in file"
        }
        else
        {
            $httpProtocolElement = $xml.CreateElement('httpProtocol')
            $httpProtocolGroup = $systemWebServerGroup.AppendChild($httpProtocolElement)
        }

        $customHeaderGroup = $httpProtocolGroup.SelectSingleNode('customHeaders')
        if ($customHeaderGroup -ne $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "<customHeaders> node already exists in file, deleting it and re-creating"
            $httpProtocolGroup.RemoveChild($customHeaderGroup)
        }

        $customHeaderElement = $xml.CreateElement('customHeaders')
        $customHeaderGroup = $httpProtocolGroup.AppendChild($customHeaderElement)

        $customHeaderGroup.AppendChild((CreateXMLElementWithAttributes -xml $xml -attributeName 'Access-Control-Allow-Credentials' -attributeValue 'true'))
        $customHeaderGroup.AppendChild((CreateXMLElementWithAttributes -xml $xml -attributeName 'Access-Control-Allow-Headers' -attributeValue 'content-type'))
        $customHeaderGroup.AppendChild((CreateXMLElementWithAttributes -xml $xml -attributeName 'Access-Control-Allow-Origin' -attributeValue $PAMportalURL))
        
        $xml.Save($PAMRestAPIWebConfig)
    }
    else
    {
        throw "Unable to find Web.Config file '$PAMRestAPIWebConfig'"
    }

}

Function ConfigurePAMRestAPIutilsFile
{
    #Configure the sample web application. 
    #Edit the file "C:\Program Files\Microsoft Forefront Identity Manager\2010\Privileged Access Management Portal\js\utils.js"
    #In that file, set the value of pamRespApiUrl to "http://pamsrv.priv.contoso.local:8086/api/pamresources/"
    #$RestAPIResourceURL

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Modifying PAM portal file '$PAMPortalJSUtilsFile' to set pamRespApiUrl setting to '$RestAPIResourceURL'"
    if (test-path -Path "$PAMPortalJSUtilsFile")
    {
        $fileStatus = Get-ChildItem "$PAMPortalJSUtilsFile"
        $fileReadonlyStatus=$fileStatus.isreadonly

        $backupName="$PAMPortalJSUtilsFile.bak"
        
        if (-not (test-path -Path "$backupName"))
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Backing up utils.js to $backupName"

            Copy-Item "$PAMPortalJSUtilsFile" "$backupName"
        }


         If ($fileStatus.isreadonly)
         {

            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "The file, $fileStatus.fullname is a read-only file - resetting read-only flag"
            $fileStatus.set_isreadonly($False)
         }


        $Sel = select-string -pattern "$RestAPIResourceURL" -path "$PAMPortalJSUtilsFile"
        if ($sel -ne $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "File already modified"
        }
        else
        {
            $StringToReplace="http://localhost:8086/api/pamresources/"
            $Sel = select-string -pattern "$StringToReplace" -path "$PAMPortalJSUtilsFile"
            if ($sel -eq $null)
            {
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "Warning: could not find '$StringToReplace' in the file!"
            }
            else
            {
                (Get-Content $PAMPortalJSUtilsFile).replace("$StringToReplace","$RestAPIResourceURL")| Set-Content "$PAMPortalJSUtilsFile"

                If ($fileReadonlyStatus)
                {

                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Resetting read-only flag for file $fileStatus.fullname"
                    $fileStatus.set_isreadonly($True)
                }


                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "File modified - performing IISeset"
                IISreset
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "IISeset completed"
            }

        }
    }
    else
    {
        throw "Unable to find portal utils.js file '$PAMRestAPIWebConfig'"
    }
}


#region PostInstall

Function CheckRESTinstalled
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Checking that REST API has been installed - $PAMRESTAPIfile"
    if (Test-Path -Path "$PAMRESTAPIfile")
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "REST file exists"

        #$stuff = Invoke-RestMethod -Uri http://localhost -Method Get

    }
    else
    {
        Throw "Could not find REST file, aborting..."
    }
}

Function ValidateDomainUserCredentials( [String]$username,  [String]$password)
{
    $message = "Validating user :" + $username
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    
    $separatorIndex = $username.IndexOf('\') ;
        
    $domainName = $username.Substring(0, $separatorIndex);

    $user = $username.Substring($separatorIndex+1, ($username.Length - $separatorIndex)-1)

    Add-Type -AssemblyName System.DirectoryServices.AccountManagement

    $accountManagementContextType = [System.DirectoryServices.AccountManagement.ContextType]::Domain
    $accountManagementPrincipalContext = New-Object System.DirectoryServices.AccountManagement.PrincipalContext $accountManagementContextType,$domainName
        
    $result = $accountManagementPrincipalContext.ValidateCredentials($user,$password)

    return $result;
}

Function Get-PAMUserCredentials
{
    param(
        [Parameter(Mandatory=$true)][Object]$xmlRoot
    )

    $accounts = $xmlRoot.Accounts    

    foreach($account in $accounts.Account)
    {
        switch($account.Type)
        {
            "MonitorAccount" 
                {
                    $resultData = $true
                    do
                    {   
                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:PAM_MONITORING_SERVICE_ACCOUNT_NAME = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD = Get-PlainTextFromSecureString $SecureString
                        
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:PAM_MONITORING_SERVICE_ACCOUNT_PASSWORD

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)
                }
            "ComponentAccount" 
                { 
                    $resultData = $true
                    do
                    {   

                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:PAM_COMPONENT_SERVICE_ACCOUNT_NAME = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD = Get-PlainTextFromSecureString $SecureString
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:PAM_COMPONENT_SERVICE_ACCOUNT_PASSWORD

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)

                }
            "MAAccount" 
                {
                    $resultData = $true
                    do
                    {   

                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:SYNC_ADMIN_ACCOUNT_NAME = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:SYNC_ADMIN_ACCOUNT_PASSWORD = Get-PlainTextFromSecureString $SecureString
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:SYNC_ADMIN_ACCOUNT_PASSWORD

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)

                }
            "ServiceAccount" 
                { 
                    $resultData = $true
                    do
                    {
                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:PAM_SERVICE_ACCOUNT_NAME = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:PAM_SERVICE_ACCOUNT_PASSWORD = Get-PlainTextFromSecureString $SecureString
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:PAM_SERVICE_ACCOUNT_PASSWORD

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)
                }
            "AdminAccount" 
                { 
                    $resultData = $true
                    do
                    {   

                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:AdminAccount = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:AdminPassword = Get-PlainTextFromSecureString $SecureString
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:AdminPassword

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)
                }
            "SharePointAccount" 
                { 
                    $resultData = $true
                    do
                    {
                        $Global:AccountDescription = $account.Description + "(" + $account.Name + ")"
                        $Global:SharePointAccountName = $account.Name
                        $SecureString = Read-Host "Please provide the password for $Global:AccountDescription" -AsSecureString
                        $Global:SharePointAccount_Password = Get-PlainTextFromSecureString $SecureString

                        $Global:PAM_REST_API_APPPOOL_ACCOUNT_NAME=$SharePointAccountName
                        $Global:PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD=$SharePointAccount_Password
                        $domainUser = $Global:PrivDomain.NetbiosName + "\" + $account.Name
                        $resultData = ValidateDomainUserCredentials $domainUser $Global:PAM_REST_API_APPPOOL_ACCOUNT_PASSWORD

                        if($resultData -eq $false)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
                        }

                    }while($resultData -eq $false)
                }
        }
    }
}
Function UpdateLocalSecurityPolicy
{
    param(
        [Parameter(Mandatory=$true)][Object]$xmlRoot
    )

    $accounts = $xmlRoot.Accounts
    foreach($account in $accounts.Account)
    {
        $accountUserName = $account.Name
        $userAccount = "$Domain\$accountUserName"
        switch($account.Type)
        {
            "MonitorAccount" 
                { 
                    Configure-LocalSecurityPolicy $userAccount "SeServiceLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyInteractiveLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyNetworkLogonRight"
                }
            "ComponentAccount" 
                { 
                    Configure-LocalSecurityPolicy $userAccount "SeServiceLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyInteractiveLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyNetworkLogonRight"
                }
            "MAAccount" 
                {
                    Configure-LocalSecurityPolicy $userAccount "SeDenyInteractiveLogonRight"
                }
            "ServiceAccount" 
                {  
                    Configure-LocalSecurityPolicy $userAccount "SeServiceLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyInteractiveLogonRight"
                    Configure-LocalSecurityPolicy $userAccount "SeDenyNetworkLogonRight"                    
                }
            "SharePointAccount" 
                { 
                    Configure-LocalSecurityPolicy $userAccount "SeServiceLogonRight"                    
                }
            "SQLServerAccount" 
                { 
                    Configure-LocalSecurityPolicy $userAccount "SeServiceLogonRight"                    
                }       
        }
    }
}


Function InstallPAM-ConfigurePAMAndCreatePortal
{
    try
    {        
        
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Install completed"

    }
    catch
    {
        if (IsRestartRequired)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Restarting computer"

            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "After restart - the script should re-launch"

            $RunOnceKey = "HKLM:\Software\Microsoft\Windows\CurrentVersion\RunOnce" 
            Set-ItemProperty -Path "$RunOnceKey" -Name "SharePoint reboot" -Value "$PSHOME\powershell.exe -ExecutionPolicy Unrestricted -File `"$CurrentScript`""

            $WinLogonKey= "HKLM:\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon"
            Set-ItemProperty $WinLogonKey "DefaultUserName" "$AdminAccount" 
            Set-ItemProperty $WinLogonKey "DefaultPassword" "$AdminPassword" 
            Set-ItemProperty $WinLogonKey "AutoAdminLogon" "1" 
            Set-ItemProperty $WinLogonKey "AutoLogonCount" "1"
            Set-ItemProperty $WinLogonKey "DefaultDomainName" "$Domain"

            Write-divider
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "The server needs to reboot. Please save your work and press enter..."
            Write-divider
            pause

            Restart-Computer -Force
        }
        else
        {
            Write-divider
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Script halted!"
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "$_.Exception -  $_.ScriptStackTrace"

        }

    }

}

###############Install MIMPAM Client Functions#############
Function Install-MIMPAMClient
{

    $RMS_LOCATION=$env:COMPUTERNAME
    $PORTAL_LOCATION=$env:COMPUTERNAME
    $PAMServer = $MIMRole.Machines.Machine.Attributes["Name"].Value
    $REGISTRATION_PORTAL_URL="http://" + $PAMServer + ":8080"
    $ACCEPT_EULA=1
    $FIREWALL_CONF=1
    $ADDLOCAL="All"
    $SQMOPTINSETTING=1
    #$FEATURES_TO_INSTALL="PAMPowershellModule"
    $FEATURES_TO_INSTALL="PAMRequesterPowerShellModule"

    if(Test-Path -Path "$MIMPAMClientMSILOCATION\$MIMPAMClientMSIFILENAME")
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Validating the PAM is already installed or not on target server"
        if (IsMIMPAMCLientinstalled)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "MIM with PAM already installed"
        }
        else
        {
            $ArgumentList="/i ""$MIMPAMClientMSILOCATION\$MIMPAMClientMSIFILENAME"" PAM_SERVER_URL=$PAMServer PAM_SERVER_ADDRESS=$REGISTRATION_PORTAL_URL ACCEPT_EULA=$ACCEPT_EULA ADDLOCAL=$FEATURES_TO_INSTALL /l*v $LOGFILENAME /qn"

            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Installing PAM client using MSIExec.exe with arguments -> $ArgumentList" 
            $p=Start-Process "MSIEXEC.EXE" -ArgumentList "$ArgumentList" -PassThru -Wait

            $exitCode = $p.ExitCode # = executeProcess -command "MSIEXEC.EXE" -arguments "$ArgumentList"
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Process completed with Exit code -> $exitCode.  Please check the log file $LOGFILENAME for more information." 
                    
            if ($exitCode -ne 3010)
            {
                if ($exitCode -eq 1602)
                {
                    throw "Install aborted by the user"
                }
                elseif($exitCode -eq 0)
                {
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Installation completed successfully." 
                }
                else
                {
                    throw "Install of MIM returned to exit code $ExitCode"
                }
            }
        }
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Did not find the 'Add-ins and extensions.msi' in $MSILOCATION.  Please fix the path in PAMDeploymentConfig file. " 
        throw
    }
}

Function IsMIMPAMCLientinstalled
{
    #TODO: need to validate client installed
    #C:\Program Files\Microsoft Forefront Identity Manager\2010\PowerShell Modules\MIMPAM\MIMPAM.psd1
    
    $FileToTest="C:\Program Files\Microsoft Forefront Identity Manager\2010\PowerShell Modules\MIMPAM\MIMPAM.psd1"

    if (test-path -Path "$FileToTest")
    {
        Return $True
    }
    else
    {
        Return $False
    }
    
    
}


###############Install SharePoint Functions#############
Function Get-SharePointInstall
{
    # Check for SharePoint by looking for install file!
    If (Test-Path "$SharePoint2013Install\BIN\stsadm.exe")
    {
        return $true
    }
    Else 
    {
        return $false
    }    

}

#Add SharePoint cmdlets to this powershell session
Function Load-SharePointPowerShell
{
    If ((Get-PsSnapin |?{$_.Name -eq "Microsoft.SharePoint.PowerShell"})-eq $null)
    {
        Write-Divider
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Loading SharePoint PowerShell Snappin script"

        If (Confirm-LocalSession)
        {
            $Host.Runspace.ThreadOptions = "ReuseThread"
        }
        Add-PsSnapin Microsoft.SharePoint.PowerShell -ErrorAction Stop | Out-Null
        Write-Divider
    }
}


Function Get-XMLElement
{
    Param
    (
        [Xml.XmlElement[]] $xmlElements,
        [string] $attributeName
    )
    $resultElement = $null
    foreach($innerElement in $xmlElements)
    {
        if($innerElement.Attributes['name'].Value.ToLowerInvariant().Equals($attributeName))
        {
            $resultElement=$innerElement
        }
    }
    return $resultElement
}

function UpdateApplicationHostConfig
{

    $applicationHostConfigFile = "C:\Windows\System32\inetsrv\config\applicationHost.config"    
    
    if (test-path -Path "$applicationHostConfigFile")
    {
        $xml = New-Object XML
        $xml = [xml](Get-Content $applicationHostConfigFile)
        
        $sectionGroupNodes=$xml.SelectNodes('/configuration/configSections/sectionGroup')
        
        $webServerNode = Get-XMLElement $sectionGroupNodes "system.webserver"
        $securityNode = Get-XMLElement $webServerNode.ChildNodes "security"
        $authenticationNode = Get-XMLElement $securityNode.ChildNodes "authentication"
        $windowsAuthenticationNode = Get-XMLElement $authenticationNode.ChildNodes "windowsauthentication"
        
        
        if($windowsAuthenticationNode.Attributes['overrideModeDefault'].value.ToLowerInvariant().Equals('deny'))
        {
            Write-Host "Updating windows authentiation mode to allow"
            $windowsAuthenticationNode.SetAttribute("overrideModeDefault","Allow")
        
            $xml.Save($applicationHostConfigFile)    
        }
        else
        {
            Write-Host "Windows authentiation mode is already set to allow"
        }
    }
    else
    {
        throw "Unable to find application.Config file '$applicationHostConfigFile'"
    }

}

#PreRequisiteInstaller
function InstallPrerequisites()
{
    $PrerequisitesExists = $false
  

    $spInstalled = Get-SharePointInstall
    If ($spInstalled)
    {
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SharePoint prerequisites appear be already installed - skipping install."
    }
    Else
    {
        $MissingPreReqs=""
        $abort=$false

        if($SharePointPrerequisites -ne $null -and $SharePointPrerequisites -ne "")
        {
            if(Test-Path -Path $SharePointPrerequisites)
            {
                $PrerequisitesExists = $True
            }
        }

        if($PrerequisitesExists)
        {
            if (-not (Test-Path -Path "$SharePointPrerequisites\sqlncli.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\sqlncli.msi"
                $abort=$true
            }
        
            if (-not (Test-Path -Path "$SharePointPrerequisites\Windows6.1-KB974405-x64.msu"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\Windows6.1-KB974405-x64.msu"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\MicrosoftIdentityExtensions-64.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\MicrosoftIdentityExtensions-64.msi"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\Synchronization.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\Synchronization.msi"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\WindowsServerAppFabricSetup_x64.exe"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\WindowsServerAppFabricSetup_x64.exe"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\AppFabric1.1-RTM-KB2671763-x64-ENU.exe"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\setup_msipc_x64.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\setup_msipc_x64.msi"
                $abort=$true
            }
                
            if (-not (Test-Path -Path "$SharePointPrerequisites\WcfDataServices.exe"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\WcfDataServices.exe"
                $abort=$true
            }

                    if (-not (Test-Path -Path "$SharePointPrerequisites\PowerShellTools.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\PowerShellTools.exe"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\SharedManagementObjects.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\SharedManagementObjects.msi"
                $abort=$true
            }

            if (-not (Test-Path -Path "$SharePointPrerequisites\SQLSysClrTypes.msi"))
            {
                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Cannot find Prerequisite $SharePointPrerequisites\SQLSysClrTypes.msi"
                $abort=$true
            }

            if ($abort)
            {
                throw " - Missing prerequisites"
            }

        }
       
        try
        {      
            if($PrerequisitesExists)
            {
            
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Prerequisites binaries are exists and starting installation"

                Start-Process "$SharePointInstallFolder\PrerequisiteInstaller.exe" -ArgumentList "/unattended /Continue `
                                                          /SQLNCli:`"$SharePointPrerequisites\sqlncli.msi`" `
                                                          /IDFX:`"$SharePointPrerequisites\Windows6.1-KB974405-x64.msu`" `
                                                          /IDFX11:`"$SharePointPrerequisites\MicrosoftIdentityExtensions-64.msi`" `
                                                          /Sync:`"$SharePointPrerequisites\Synchronization.msi`" `
                                                          /AppFabric:`"$SharePointPrerequisites\WindowsServerAppFabricSetup_x64.exe`" `
                                                          /KB2671763:`"$SharePointPrerequisites\AppFabric1.1-RTM-KB2671763-x64-ENU.exe`" `                                                                                             
                                                          /MSIPCClient:`"$SharePointPrerequisites\setup_msipc_x64.msi`" `
                                                          /WCFDataServices:`"$SharePointPrerequisites\WcfDataServices.exe`""

                Show-Progress -Process PrerequisiteInstaller -Color Cyan -Interval 5 -msg PrerequisiteInstaller.exe

                Start-Process "$SharePointPrerequisites\SQLSysClrTypes.msi" /passive -Wait
                Start-Process "$SharePointPrerequisites\SharedManagementObjects.msi" /passive -Wait
                Start-Process "$SharePointPrerequisites\PowerShellTools.msi" /passive -Wait
                Start-Process "$SharePointPrerequisites\WcfDataServices.exe" /passive -Wait
                Start-Process "$SharePointPrerequisites\WcfDataServices56.exe" /passive -Wait

                Write-divider
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Prerequisites installation is completed and server needs to reboot. Please save your work and press enter..."
                Write-divider

                Pause

                Restart-Computer -Force
            }
            else
            {
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Prerequisites binaries are does not exists, downloading and starting installation"

                $PrerequistInstaller = "$SharePointInstallRoot\sp\prerequisiteinstaller.exe"
                $proc = Start-Process $PrerequistInstaller -ArgumentList "/unattended /Continue" -PassThru
                
                Show-Progress -Process PrerequisiteInstaller -Color Cyan -Interval 5 -msg PrerequisiteInstaller.exe

                $resultcode = $proc.ExitCode
                
                if($resultcode -eq 0)
                {
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Prerequisites binaries already installed."
                }
                if ($resultcode -eq 1001)
                {
                
                    Write-divider
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "A pending restart blocks installation.  Please rerun the script after reboot after saving your current work..."
                    Write-divider

                    Pause

                    Restart-Computer -Force
                }
                if ($resultcode -eq 3010)
                {
                    Write-divider
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Prerequisites installation is completed and server need to reboot."
                    
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Please run PAMDeployment.ps1 and select (SharePoint Setup) after the server restarts to continue SharePoint installation. Please save your current work before rebooting..."
                    Write-divider
                    Pause

                    Restart-Computer -Force
                }
            }

        } #try
        Catch
        {
            Write-Host -ForegroundColor Cyan "."
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message " - Error: $_ $LASTEXITCODE"

            If ($LASTEXITCODE -eq "1") {Throw " - Another instance of this application is already running"}
            ElseIf ($LASTEXITCODE -eq "2") {Throw " - Invalid command line parameter(s)"}
            ElseIf ($LASTEXITCODE -eq "1001") {Throw " - A pending restart blocks installation"}
            ElseIf ($LASTEXITCODE -eq "3010") {Throw " - A restart is needed"}
            ElseIf ($LASTEXITCODE -eq "-2145124329") {$reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - A known issue occurred installing one of the prerequisites"; InstallPreRequisites ([xml]$xmlinput)}
            Else {Throw " - An unknown error occurred installing prerequisites"}
        } #catch

        $preReqLog = Get-ChildItem -Path (Get-Item $env:TEMP).FullName | ? {$_.Name -like "PrerequisiteInstaller.*"} | Sort-Object -Descending -Property "LastWriteTime" | Select-Object -first 1
        If ($preReqLog -eq $null)
        {
            Write-Warning "Could not find PrerequisiteInstaller log file"
        }
        Else
        {
            # Get error(s) from log
            $preReqLastError = $preReqLog | Select-String -SimpleMatch -Pattern "Error" -Encoding Unicode | ? {$_.Line  -notlike "*Startup task*"}
            If ($preReqLastError)
            {
                ForEach ($preReqError in ($preReqLastError | ForEach {$_.Line})) {Write-Warning $preReqError}
            }
            # Look for restart requirement in log
            $preReqRestartNeeded = ($preReqLog | Select-String -SimpleMatch -Pattern "0XBC2=3010" -Encoding Unicode) -or ($preReqLog | Select-String -SimpleMatch -Pattern "0X3E9=1001" -Encoding Unicode)
            If ($preReqRestartNeeded -or $preReqKnownIssueRestart)
            {
                Set-RestartRequired
                throw " - At least one of the PreRequisites require a restart"
            }
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message " - All Prerequisite Software installed successfully."
        }
 
    } #SP already installed
}


function InstallSharePoint
{
    
    InstallPrerequisites

    UpdateApplicationHostConfig

    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Starting SharePoint 2013 setup.exe"

    start-process "$SharePointInstallFolder\setup.exe"
    # -ArgumentList "/Config `"$SharePointInstallFolder\files\setupsilent\config.xml`""
          
    Show-Progress -Process setup -Color Cyan -Interval 5 -msg setup.exe
            
    # Parsing most recent SharePoint Server Setup log for errors or restart requirements, since $LASTEXITCODE doesn't seem to work...
    $setupLog = Get-ChildItem -Path (Get-Item $env:TEMP).FullName | ? {$_.Name -like "*SharePoint * Setup*"} | Sort-Object -Descending -Property "LastWriteTime" | Select-Object -first 1
    If ($setupLog -eq $null)
    {
        Throw " - Could not find SharePoint Server Setup log file in $env.TEMP!"
    }

    # Get error(s) from log
    $setupLastError = $setupLog | Select-String -SimpleMatch -Pattern "Error:" | Select-Object -Last 1
    $setupSuccess = $setupLog | Select-String -SimpleMatch -Pattern "Successfully installed package: wss"
    If ($setupLastError -and !$setupSuccess)
    {
        Write-Warning $setupLastError.Line
        Invoke-Item -Path "$((Get-Item $env:TEMP).FullName)\$setupLog"
        #Throw " - Review the log file and try to correct any error conditions."
    }
    # Look for restart requirement in log
    $setupRestartNotNeeded = $setupLog | select-string -SimpleMatch -Pattern "System reboot is not pending."
    If (!($setupRestartNotNeeded))
    {
        Set-RestartRequired
        Throw " - SharePoint setup requires a restart. Run the script again after restarting to continue."
    }

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Wait for configuration wizared to complete the configuration."

    Pause

    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SharePoint Installation completed."


    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Starting the SharePoint configuration"
            
    Pause

    AddPostSharePointFeatures
}
function AddPostSharePointFeatures
{
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Executing Post SharePoint installation script to create Web Application"

    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Adding SharePoint commands to this session"
    Load-SharePointPowerShell

    
    $SharePointUserName = Get-AccountForRole SharePoint ServiceAccount
    $SharePointAccount = "$Domain\$SharePointUserName"
    
    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Loading SP Managed Account - $SharePointAccount"
    $dbManagedAccount = Get-SPManagedAccount -Identity $SharePointAccount -ErrorAction SilentlyContinue

    if($dbManagedAccount -eq $null)
    {
        Write-divider
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Could not find SharePoint ManageAccount.  Please create new account using New-SPManagedAccount for $SharePointAccount"
        Write-divider
        throw
    }

    $webApplication = Get-SPWebApplication | where {$_.DisplayName -eq "MIM Portal"}
    if ($webApplication -eq $null)
    {
  
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Creating SP Web Application MIM Portal"

        $ServerName = $global:SPRole.Machines.Machine.Name
        $PortalURL = "http://$ServerName"

        New-SpWebApplication -Name "MIM Portal" -ApplicationPool "MIMAppPool"-ApplicationPoolAccount $dbManagedAccount -AuthenticationMethod "Kerberos" -Port 82 -URL $PortalURL
        $webApplication = Get-SPWebApplication | where {$_.DisplayName -eq "MIM Portal"}
        if ($webApplication -eq $null)
        {
            throw " - error creating new SP Web Application $PortalURL"
        }
    }
    else
    {
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SP Web Application MIM Portal already exists"
    }

    $template = Get-SPWebTemplate -compatibilityLevel 14 -Identity "STS#1"
    if ($template -eq $null)
    {
        throw " - Unable to find SPWebTemplate STS#14 with compatibility level 14"
    }

    $site = spsite $webApplication.url -ErrorAction SilentlyContinue
    if ($site -eq $null)
    {
        

        $AdminUserName = Get-AccountForRole MIM AdminAccount
        if($AdminUserName -eq $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Error  "MIM Admin Account is null.  Please update the xml configuration file with MIM Admin Account details"
        }
        $DomainAccount = "$Domain\$AdminUserName"

        $BackupAdminUserName = Get-AccountForRole "Sharepoint" BackupAccount
        if($BackupAdminUserName -eq $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Error  "MIM Backup Admin Account is null.  Please update the xml configuration file with MIM Backup Admin Account details"
        }

        $DomainAccountSecondaryOwnerAlias = "$Domain\$BackupAdminUserName"
        

        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Creating SPSite"
        New-SPSite -Url $webApplication.Url -Template $template -OwnerAlias $DomainAccount -CompatibilityLevel 14 -Name "MIM Portal" -SecondaryOwnerAlias $DomainAccountSecondaryOwnerAlias
        $site = SpSite($webApplication.Url)
        if ($site -eq $null)
        {
            thow " - error creating new SP Site $webApplication.Url"
        }
    }
    else
    {
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SPSite already exists"
    }

    $site.AllowSelfServiceUpgrade = $false
    if ($site.CompatibilityLevel -ne 14)
    {
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message " - Compatibility level is $s.CompatibilityLevel rather than 14!"
        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message " - http://technet.microsoft.com/en-us/library/jj863242(v=ws.10).aspx for more information)"
        if ($site.CompatibilityLevel -eq 15)
        {
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  " - Because the result is 15, the site collection was not created for the 2010 experience version; delete the site collection and recreate it."
        }
    }
    else
    {

        $contentService = [Microsoft.SharePoint.Administration.SPWebService]::ContentService
        if ($contentService -eq $null)
        {
            throw " - ContentService is null"
        }
        if ($contentService.ViewStateOnServer -ne $false)
        {
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Disable SharePoint Server-Side Viewstate"
            $contentService.ViewStateOnServer = $false;
            $contentService.Update();
        }
        else
        {
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SharePoint Server-Side Viewstate is already disabled"
        }
        $job = Get-SPTimerJob hourly-all-sptimerservice-health-analysis-job
        if ($job -eq $null)
        {
            throw " - unable to find SP Timer Job called hourly-all-sptimerservice-health-analysis-job"
        }
        if ($job.IsDisabled -eq $true)
        {
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SharePoint job hourly-all-sptimerservice-health-analysis-job is already disabled"
        }
        else
        {
            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - Disabled SharePoint job hourly-all-sptimerservice-health-analysis-job"
            Get-SPTimerJob hourly-all-sptimerservice-health-analysis-job | disable-SPTimerJob
        }

        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message " - Launching MIM Portal site"
        [System.Diagnostics.Process]::Start("http://localhost:82/")
    }


}


###############Install SQL Functions#############
Function Install-SQLServer
{

    $SQLServerSetupPath = $Global:SQLRole.BinaryLocation.'#text'
    
    $message = "Validating SQL Server Setup path"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message


    if(Test-Path -Path $SQLServerSetupPath)
    {
        Set-Location $SQLServerSetupPath

        $SQLServerSAUserName = Get-AccountForRole SQL ServiceAccount
        $netbiosName = ${PrivDomain}.NetbiosName
        $SQLSAAccount = "${netbiosName}\$SQLServerSAUserName"
        $SQLSAUserPasswordSecure = Read-Host "Please provide the password for $SQLSAAccount" -AsSecureString
        $SQLSAUSerPassword = Get-PlainTextFromSecureString $SQLSAUserPasswordSecure

        $SQLMIMSAUserName = Get-AccountForRole MIM AdminAccount
        $SQLMIMSAUserAccount = "${netbiosName}\$SQLMIMSAUserName"

        $ArgumentList = "/Q /IACCEPTSQLSERVERLICENSETERMS /ACTION=install /FEATURES=SQL,SSMS /INSTANCENAME=MSSQLSERVER /SQLSVCACCOUNT=""$SQLSAAccount"" /SQLSVCPASSWORD=""$SQLSAUserPassword"" /AGTSVCSTARTUPTYPE=Automatic /AGTSVCACCOUNT=""NT AUTHORITY\Network Service"" /SQLSYSADMINACCOUNTS=""$SQLMIMSAUserAccount"""  

        $message = "Starting SQL Server installation in unattended mode"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

        
        $p=Start-Process "$SQLServerSetupPath\Setup.EXE" -ArgumentList "$ArgumentList" -PassThru -Wait

        $resultCode = $p.ExitCode
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Process exited with $resultCode"
        if($resultCode -eq 0)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "SQL Install Succeeded."
        }
        else
        {
             Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "SQL Install failed."
        }
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "SQL setup binary location does not exist."
        throw
    }
}

Function Add-DomainJoin
{
    Param(
        [string] $domainName
    )

    if ((gwmi win32_computersystem).partofdomain -eq $true) 
    {
        $message = "Server is already domain joined to " + $domainName
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message


        if($domainName -eq $Global:PrivDomain.DNSName)
        {
            AddUsersToAdminGroup

            $message = "The current logged in user is " + [Environment]::UserName
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

            $mimAdminUserName = Get-AccountForRole MIM AdminAccount
            if([Environment]::UserName -ne $mimAdminUserName)
            {
                $message = "Please login with $mimAdminUserName account to continue setup."
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  $message

                Write-divider
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "The server needs to logoff. Please save your work and press enter..."
                Write-divider
                pause

                logoff.exe
            }
        }
    }
    else 
    {
        $message = "Joining the computer to domain : - " + $domainName
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    
        #Request-SetDNSServer

        $dnsName = $domainName

        $resultData = $true
        do
        {
            $userName = Read-Host "Enter domain user name do domain join the server $dnsName\"
            $SecurePassword = Read-Host "Enter password for ${userName}" -asSecureString  
            $qualifiedUserName = "${dnsName}\${userName}"

            $plainPassword = Get-PlainTextFromSecureString $SecurePassword
            
            $resultData = ValidateDomainUserCredentials $qualifiedUserName $plainPassword

            if($resultData -eq $false)
            {
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "User validation failed with given user creds."
            }

        }while($resultData -eq $false)

        $creds = new-object System.Management.Automation.PSCredential -ARgumentList $qualifiedUserName, $SecurePassword

        #$domainCredentials = Get-Credential "Enter Domain User Credentials to Join $domainName"
        #$domainCredentials = $host.ui.PromptForCredential("Need " + $domainName + "user credentials", "Please enter domain user name and password to join "+ $domainName +".", "", "NetBiosUserName")
        
        Try
        {
            Add-Computer -DomainName $domainName -Credential $creds -ErrorAction Stop
        
            if($domainName -eq $Global:PrivDomain.DNSName)
            {                
                $message = "Domain join completed and adding MIM users to local administrator group"
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
        

                AddUsersToAdminGroup
            }
    
            Write-divider
            $message = "Restarting the server after Domain Join, Please save your work and press enter..."
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
            Write-divider

            Pause

            Restart-Computer -Force
        }
        catch
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Domain join failed with excption - $_.Exception"
            throw
        }        
    }
}

Function Get-PlainTextFromSecureString {
    
    param
    ( 
        [Parameter(Mandatory=$true)][System.Security.SecureString] $securePassword
    )
        
    $ptrPassword = [Runtime.InteropServices.Marshal]::SecureStringToBSTR($securePassword)
    
    $plainTextPassword = [Runtime.InteropServices.Marshal]::PtrToStringAuto($ptrPassword)
        
    [Runtime.InteropServices.Marshal]::ZeroFreeBSTR($ptrPassword)
    
    $plainTextPassword
}

Function AddUsersToAdminGroup
{
    $userName = Get-AccountForRole MIM AdminAccount
    Add-UserToAdministratorGroup $userName

    if(($Global:selectOptionResult -eq 4) -or ($Global:selectOptionResult -eq 5))
    {
        $userName = Get-AccountForRole MIM MonitorAccount
        Add-UserToAdministratorGroup $userName

        #06/13/2016 : BinilK : Based on updated documents, we don't need
        #to add mimservice & mimcomponent as administrators
        #$userName = Get-AccountForRole MIM ComponentAccount
        #Add-UserToAdministratorGroup $userName

        #$userName = Get-AccountForRole SharePoint ServiceAccount
        #Add-UserToAdministratorGroup $userName
    }
}

Function Add-UserToAdministratorGroup
{
    Param
    (
        [string] $userName
    )

    $result = net localgroup administrators | Where {$_ -match $userName}
    if($result -eq $null)
    {
        $message = "Adding $userName to local administrators group"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message

        $Domain = $PrivDomain.DNSName
        
        net localgroup administrators $Domain\$userName /add
        
        $message = "$userName added to local administrators group with result code $resultCode"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    }
    else
    {
        $message = "$userName already exists in local administrators group"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    }

    
}

Function PreparePAMServer-RevokeRoles
{
    Remove-WindowsRole $webRole    
    Remove-WindowsRole $rsatAdPowerShell
    Remove-WindowsRole $webMgmtTools
    Remove-WindowsRole $applicationServer
    Remove-WindowsRole $windowsIdentityFoundation
    Remove-WindowsRole $serverMedaionFoundation
    Remove-WindowsRole $xpsViewer
    Remove-WindowsRole $netFramework
}

Function PreparePAMServer-InstallRoles
{
    Add-WindowsRole $webRole    
    Add-WindowsRole $rsatAdPowerShell
    Add-WindowsRole $webMgmtTools
    Add-WindowsRole $applicationServer
    Add-WindowsRole $windowsIdentityFoundation
    Add-WindowsRole $serverMedaionFoundation
    Add-WindowsRole $xpsViewer
    Add-WindowsRole $netFramework
}


Function Add-WindowsRole
{
    Param
    (
        [string] $role
    )

    $message = "Validating the '$role' installed on server" 
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    $installRole = Get-WindowsFeature $role

    if($installRole.Installed -ne "True")
    {

        Install-WindowsFeature $role -IncludeAllSubFeature -IncludeManagementTools

        $message = "'$role' installation completed" 
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    }
    else
    {
        $message = $role + "is already installed on server"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  $message
    }
}



###############PAMDeployment Functions#############


#####This came from CommonFunctions.psm1#######
Function Get-LogFileName
{
    # log file name returned in format [$path\]filename_20150603T120101.log
    param(
        [Parameter(Mandatory=$true)] [string]$fileName, 
        [Parameter(Mandatory=$false)] [string]$path)
    # TODO: should we validate the path exists?
    if (!$path.EndsWith("\"))
    {
        $path = $path + "\"
    }
    $d = (Get-Date).ToString("yyyyMMddThhmmss")
    return $path + $filename+ "_" + $d + ".log"
}

Function Import-PAMDeployModule
{
    Param(
    [string]$deployFolder,
    [string]$moduleName
    )
    $bReturn = $false
    $error.Clear()
    $modulePath = $deployFolder + '\' + $moduleName
    #Write-Host -ForegroundColor Green Attempting to load module $modulePath
    if (Test-Path $modulePath)
    {
        Try
        {
            #import-module $modulePath -ErrorAction SilentlyContinue
            import-module $modulePath 
            #Write-Host -ForegroundColor Green Successfully loaded module $modulePath
        $bReturn = $true
        }
        Catch
        {
            if ($error.Count -gt 0)
            {
                Write-Host -ForegroundColor Red $error[0].Exception.Message
                # TODO: Should we exit or continue?
                exit
            }
        }
    }
    else
    {
        $message = [string]::Format("Did not find {0} in {1}", $moduleName, $deployFolder)
        Write-host -ForegroundColor Red $message
        # TODO: Should we exit or continue
        exit
    }
    #return $bReturn
}

function Import-Settings
{
    param(
        [Parameter(Mandatory=$true)][Object]$xmlRoot
    )

    $domains = $xmlRoot.PAMDeploymentConfiguration.Domains
    $roles = $xmlRoot.PAMDeploymentConfiguration.Roles
    $privOnlyStr = $xmlRoot.PAMDeploymentConfiguration.PrivOnly
    $global:PrivOnly = [System.Convert]::ToBoolean($privOnlyStr)

    foreach($dom in $domains.Domain)
    {
        switch($dom.Type)
        {
            "CORP" { $Global:CorpDomain = $dom }
            "PRIV" { $Global:PrivDomain = $dom }
        }
    }

    foreach($role in $roles.Role)
    {
        switch($role.Type)
        {
            "ADDS" { $Global:ADDSRole = $role }
            "SQL" { $Global:SQLRole = $role }
            "SharePoint" { $Global:SPRole = $role }
            "MIM" { $Global:MIMRole = $role }
        }
    }
}


#function Extract-Child
#{
#    param(
#        [Parameter(Mandatory=$true)][Object]$rootDoc,
#        [Parameter(Mandatory=$true)][string]$nodeName
#    )
#    $retVal = $rootDoc | select -ExpandProperty ChildNodes | where {$_.Name -like $nodeName } 
#    return $retVal
#}

function Get-InnerValue
{
    param(
        [Parameter(Mandatory=$true)][Object]$rootDoc,
        [Parameter(Mandatory=$true)][string]$nodeName
    )
    $retVal = $rootDoc | select -ExpandProperty ChildNodes | 
                where {$_.Name -like $nodeName } | select -ExpandProperty InnerText 
    return $retVal
}

function Get-DCOfType
{
    param(
         [Parameter(Mandatory=$true)][object]$rootObject,
         [Parameter(Mandatory=$true)][string]$role
    )

    $dcToReturn = $null

    foreach($dc in $rootObject.DCs.DC)
    {
        if($role.ToLowerInvariant().Equals($dc.Role.ToLowerInvariant()))
        {
            $dcToReturn = $dc
            break
        }
    }

    return $dcToReturn
}

function CheckAndInstallRSATADTools
{
    $role = 'RSAT-AD-Tools'
    $installedRole = Get-WindowsFeature $role
    if($installedRole.Installed -ne "True")
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Adding ${role} required by the deployment scripts..."
        $feature = Install-WindowsFeature $role -IncludeAllSubFeature -IncludeManagementTools
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Role ${role} already present, not changing..."
    }
}

function Get-DomainController
{
    param(
         [Parameter(Mandatory=$true)][object]$rootObject,
         [Parameter(Mandatory=$true)][string]$type
    ) 
    $dc = $null

#    if($dc -eq $null)
#    {
#        #This could be user error"
#        $message = "Cannot find DC of type ${type}, exiting..."
#        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
#        throw $message
#    }

    #We need to first check if the RSAT tools are installed. If not we need to install them.
    CheckAndInstallRSATADTools

    $dnsName = Get-InnerValue $rootObject "DNSName"
    if($dnsName -eq $null)
    {
        #This could be user error"
        $message = "Cannot find DNSName, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }

    #Let's just check if the domain exists to begin with, if so nothing to do
    try
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Checking if the Domain already exists..."
        $dc = Get-ADDomainController -Discover -DomainName $dnsName -ErrorAction SilentlyContinue
    }
    catch
    {
        throw
    }

    return $dc
}

function Get-RootObject
{
    param(
         [Parameter(Mandatory=$true)][string]$type
    ) 

    $rootObject = $null
    if($type.ToLowerInvariant().Equals("priv"))
    {
        $rootObject = $PrivDomain
    }
    elseif($type.ToLowerInvariant().Equals("corp"))
    {
        $rootObject = $CorpDomain
    }
    else
    {
        $message = "Invalid forest type while getting RootObject, exiting"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }
    return $rootObject
}

function Invoke-PAMSetupFunction
{
    param
    (
        [Parameter(Mandatory=$true)]
        [string] $functionDisplayName,

        [Parameter(Mandatory=$true)]
        [string] $functionName,
        
        [Parameter(Mandatory=$false)]
        [string] $NextFunctionMessage = ""
    )

    Get-Command -Name $functionName -Module $MyInvocation.MyCommand.Module.Name -ErrorAction SilentlyContinue -ErrorVariable getCommandError | Out-Null
    if ($getCommandError -ne $null)
    {
        Write-LogsAndDisplay -EventID $warningEventId -ErrorLevel 'Warning' ("In {0} cannot find {1}" -f $MyInvocation.MyCommand.Name, $functionName)
    }
    else
    {
        Write-LogsAndDisplay -EventID $infoEventId -ErrorLevel 'Information' "Beginning execution of $functionDisplayName"
        try 
        {
            & $functionName
            Write-LogsAndDisplay -EventID $infoEventId -ErrorLevel 'Information' "Finished execution of $functionDisplayName"
            if(-not [String]::IsNullOrEmpty($NextFunctionMessage))
            {
                Write-LogsAndDisplay -EventID $infoEventId -ErrorLevel 'Information' $NextFunctionMessage
            }
        }
        catch [Exception] 
        {
            Write-LogsAndDisplay -EventID $errorEventId -ErrorLevel 'Error' `
                -message ("Execution of {0} failed with exception:`n{1}`nScript Stack Trace:`n{2}" -f $functionDisplayName, $_.Exception.Message, $_.ScriptStackTrace)
        }
    }
}

function Install-FirstDomainController
{
    param(
         [Parameter(Mandatory=$true)][string]$type
    ) 

    $rootObject = Get-RootObject $type
    $dc = Get-DCOfType $rootObject "root"
    $dnsName = Get-InnerValue $rootObject "DNSName"
    $domain = Get-DomainController $rootObject $type
    if($domain -ne $null)
    {
        $message = "Domain with DNS Name :${dnsName} already exists, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
        throw $message
    }

    $netbiosName = Get-InnerValue $rootObject "NetbiosName"

    #Let's get the details
    $message = "Creating a ${type} domain with DNS Name :${dnsName} & NetbiosName: ${netbiosName}"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message

    #Let's get all the parameters.
    #We could check if we are running on the same machine. ToDo : V2

    $dbPath = Get-InnerValue $dc "DatabasePath"
    $logPath = Get-InnerValue $dc "LogPath"
    $sysvolPath = Get-InnerValue $dc "SysvolPath"
    $domainMode = Get-InnerValue $rootObject "DomainMode"
    $forestMode = Get-InnerValue $rootObject "ForestMode"
    $userName = $null
    $SecurePassword = $null
    $qualifiedUserName = $null

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Running Initialize-ADDSForest with the following command line"
    $command = "Initialize-ADDSForest -DomainName ${dnsName} -DatabasePath $dbPath -SysvolPath $sysvolPath -LogPath $logPath -DomainMode $domainMode -ForestMode $forestMode"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message $command

    #If it's TEST setup, we also need to delegation credentials, for CORP forest
    #Otherwise assume DNS is already setup
    if($type.ToLowerInvariant() -eq "priv" -and ($testSetup -eq $true))
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Getting credentials for creating DNS delegation"
        $userName = Read-Host "Enter user name for creating DNS delegation on CORP Forest"
        $SecurePassword = Read-Host "Enter password for ${userName}" -asSecureString  
        $qualifiedUserName = "${netbiosName}\${userName}"
        $creds = new-object System.Management.Automation.PSCredential -ArgumentList $qualifiedUserName, $SecurePassword
        Initialize-ADDSForest -DomainName ${dnsName} -DatabasePath $dbPath -SysvolPath $sysvolPath -LogPath $logPath -DomainMode $domainMode -ForestMode $forestMode -CreateDNSDelegation $true -DNSDelegationCredential $creds
    }
    else
    {
        Initialize-ADDSForest -DomainName ${dnsName} -DatabasePath $dbPath -SysvolPath $sysvolPath -LogPath $logPath -DomainMode $domainMode -ForestMode $forestMode
    }
    
}

function Get-Section
{
    param(
        [Parameter(Mandatory=$true)][object]$lines,
        [Parameter(Mandatory=$true)][string]$sectionName
    )
    foreach($line in $lines)
    {
        #We check if the section name matches
        if($line.ToLowerInvariant().Equals($sectionName.ToLowerInvariant()))
        {
            return $true
        }
    }
    return $false
}

function Set-AuditPolicy
{
    param(
        [Parameter(Mandatory=$true)][string]$tmplPath,
        [Parameter(Mandatory=$true)][string]$guid,
        [Parameter(Mandatory=$true)][string]$sectionName,
        [Parameter(Mandatory=$true)][string]$keyName,
        [Parameter(Mandatory=$true)][string]$value,
        [Parameter(Mandatory=$false)][string]$appendVal = $false
    )

    $replace = $false
    $suffix = (Get-Date).ToString("yyyyMMddhhmmssfffff")
    $tempTemplPath  = ".\GptTmpl_${suffix}.inf"
    $backupTmplPath  = "${installLogPath}\GptTmpl_${guid}_${suffix}.inf"

    if(test-path $tempTemplPath)
    {
        remove-item $tempTemplPath -ErrorAction SilentlyContinue
    }

    #We need to check if the value is already set.
    $lines = get-content $tmplPath
    $sectionExists = Get-Section $lines $sectionName
    if($sectionExists -eq $false)
    {
        #We add the whole thing at the end
        Add-Content -Path $tmplPath -Value ${sectionName} -Encoding Unicode
        Add-Content -Path $tmplPath -Value "${keyName} = ${value}" -Encoding Unicode
    }
    else
    {
        #Now this is interesting. We'll have to look for the section 
        #Then each value, add if it doesn't exist, or change if it does 
        #Walk till the section
        $keyFound = $false
        for($i = 0; $i -lt $lines.Count;)
        {
            if($lines[$i].ToLowerInvariant().Equals(${sectionName}.ToLowerInvariant()))
            {
                #Found the section!
                #Add the line first
                Add-Content -Path $tempTemplPath -Value $lines[$i++] -Encoding Unicode

                #Next iterate over the rest
                for($j = $i; $j -lt $lines.Count;$j++)
                {
                    $line = $lines[$j]

                    if($line.StartsWith("["))
                    {
                        #We are at the next section, so break
                        break;
                    }

                    #Next keep looking for the two values
                    if($line.ToLowerInvariant().Contains(${keyName}.ToLowerInvariant()))
                    {
                        $keyFound = $true
                        if($appendVal -eq $false)
                        {
                            #We replace only if the current value is not what we are trying to set to.
                            $currentVal = $line.Split("=")[1].Trim()
                            if($currentVal.ToLowerInvariant().Equals($value) -ne $true)
                            {
                                $valToReplace = ${value}
                            }
                            else
                            {
                                $valToReplace = ${currentVal}
                                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Audit Policy already updated with the right value, not updating again..."
                            }
                        }
                        else
                        {
                            $fullVal = $line.Split("=")
                            $currentVal = $fullVal[1].Trim()
                            if($currentVal.ToLowerInvariant().Contains($value.ToLowerInvariant()))
                            {
                                $valToReplace = $fullVal[1]
                                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Audit Policy already updated with the right value, not updating again..."
                            }
                            else
                            {
                                $valToReplace = $fullVal[1] + "," + ${value}
                            }
                        }

                        Add-Content -Path $tempTemplPath -Value "${keyName} = ${valToReplace}"  -Encoding Unicode
                    }
                    else
                    {
                        #We need add the other key back in the same place
                       Add-Content -Path $tempTemplPath -Value "${line}"  -Encoding Unicode
                    }
               }
               #When you are done
               if($keyFound -eq $false)
               {
                   Add-Content -Path $tempTemplPath -Value "${keyName} = ${value}"  -Encoding Unicode
               }
               
               #Reset the count to where we are now. Oh, the off-by-1s.
               $i = $j - 1
            }
            else
            {
                Add-Content -Path $tempTemplPath -Value $lines[$i] -Encoding Unicode
            }
            $i++;
        }

        $replace = $true
    }


    if($replace)
    {
        #We backup the entire file first
        Copy-Item $tmplPath $backupTmplPath
        Copy-Item $tempTemplPath $tmplPath 
    }
    return $replace
}

function Add-VersionCount
{
    param(
        [Parameter(Mandatory=$true)][string]$iniPath,
        [Parameter(Mandatory=$true)][string]$guid
    )
    $suffix = (Get-Date).ToString("yyyyMMddhhmmssfffff")
    $tempIniPath  = ".\Gpt_${suffix}.ini"
    $backupIniPath  = "${installLogPath}\Gpt_${guid}_${suffix}.ini"
    if(test-path $tempIniPath)
    {
        remove-item $tempIniPath  -ErrorAction SilentlyContinue
    }
    #Now adjust the version number
    foreach($line in (get-content $iniPath))
    {
        if($line.ToLowerInvariant().Contains("version"))
        {
            $values = $line.Split("=")
            $currentVal = $values[1].Trim()
            #Oh boy. The Joys of Scripting.
            $newVal = 1 + $currentVal
            #The encoding busted this on WS2016
            #Add-Content -Path $tempIniPath -Value "Version = ${newVal}" -Encoding Unicode
            Add-Content -Path $tempIniPath -Value "Version = ${newVal}"
        }
        else
        {
            #The encoding busted this on WS2016
            #Add-Content -Path $tempIniPath -Value $line -Encoding Unicode
            Add-Content -Path $tempIniPath -Value $line
        }
    }
    #Finally replace the file
    Copy-Item $iniPath $backupIniPath
    Copy-Item $tempIniPath $iniPath
}

function Set-AuditGroup()
{
    $netbiosName = Get-InnerValue $CorpDomain "NetbiosName"

    if([String]::IsNullOrEmpty($netbiosName) -eq $false)
    {
        #Escape is a must. $$ is special
        $groupName = "${netbiosName}" + "`$`$`$"
        $g = $null
        try
        {
            $g = get-ADGroup ${groupName} -ErrorAction SilentlyContinue
        }
        catch #Get-ADGroup still seems to ignore -ErrorAction
        {
        }

        if($g -eq $null)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Group ${groupName} does not exist, creating..."
            New-ADGroup -name "${groupName}" -GroupCategory Security -GroupScope DomainLocal
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Group ${groupName} created..."
            #ToDo:Put marker so that it can be deleted later.
        }
        else
        {
            $message = "Group ${groupName} exists, skipping creation..."
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message $message
        }
    }
    else
    {
        $message = "Unable to get NetbiosName from config file, skipping creation of group..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
    }
}

function Remove-AuditGroup()
{
    $netbiosName = Get-InnerValue $CorpDomain "NetbiosName"

    if([String]::IsNullOrEmpty($netbiosName) -eq $false)
    {
        #Escape is a must. $$ is special
        $groupName = "${netbiosName}" + "`$`$`$"
        $g = $null
        try
        {
            $g = get-ADGroup ${groupName} -ErrorAction SilentlyContinue
        }
        catch #Get-ADGroup still seems to ignore -ErrorAction
        {
        }

        if($g -eq $null)
        {
            $message = "Group ${groupName} does not exist, exiting..."
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message $message
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Group ${groupName} exists, deleting..."
            try
            {
                Remove-ADGroup $g -Confirm:$false
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -message "Group ${groupName} deleted..."
            }
            catch
            {
            }
        }
    }
    else
    {
        $message = "Unable to get NetbiosName from config file, skipping deletion of group..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
    }
}

function Set-RegistryForSAMAccess
{
    #If it exists ignore
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Setting up registry to allow access to SAM database..."
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Checking if the value is already set..."

    $val = (Get-ItemProperty -Path HKLM:SYSTEM\CurrentControlSet\Control\Lsa -Name TcpipClientSupport -ErrorAction SilentlyContinue)
    if($val -eq 1)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Value already set, not updating..."
    }
    else
    {
        New-ItemProperty -Path HKLM:SYSTEM\CurrentControlSet\Control\Lsa -Name TcpipClientSupport -PropertyType DWORD -Value 1 -ErrorAction SilentlyContinue
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Registry updated to allow access to SAM database..."
    }
}

function Set-CorpConfigurationInternal
{

    $rootObject = $null
    $domain = $null
    $dnsName = $null
    $rootObject = Get-RootObject "corp"
    $domain = Get-DomainController $rootObject "corp"
    $dnsName = Get-InnerValue $CorpDomain "DNSName"

    #Requirements
    #Corp is already promoted. If it is not, we error and return
    if($domain -eq $null)
    {
        $message = "Domain with DNS Name :${dnsName} cannot be found, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    #First check if the SIDs.txt file exists
    if((Test-Path $sidPath) -eq $false)
    {
        $message = "Cannot find a SID file ${sidPath}, this is needed for configuring permissions in CORP forest for PRIV users"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    #There are three things we need to do
    #1. Create the Domain Local group 
    #2. Configure auditing
    #3. Configure registry settings

    #1. Create Domain Local group
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Creating the Audit group if it doesn't exist..."
    Set-AuditGroup 

    #2.Configure auditing
    #We go and edit the Default Domain Controllers Policy directly, but back it up first, in case we need to rollback
    #there is also DCGPOFix.exe, but that would restore the policy back to it was since the beginning of time
    #That should be fine for PRIV, but not for CORP.
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Configuring Auditing in CORP..."

    #First find location of sysvol
    $gpTmplPath = ""
    $iniFilePath = ""
    $smbShare = get-smbshare sysvol
    $bDirty = $false
    $bAAM = $false
    $bADS = $false
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Finding the Sysvol share and the files..."
    if ($smbShare -ne $null)
    {
        $gptTmplPath = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_CONTROLLERS_GUID\MACHINE\Microsoft\Windows NT\SecEdit\GptTmpl.inf"
        $iniFilePath = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_CONTROLLERS_GUID\GPT.INI"

        if(($gptTmplPath -eq $false) -or ($iniFilePath -eq $false))
        {
            $message = "Unable to find Sysvol share, cannot update Audit Policies..."
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
            throw $message
        }

        #Adjust the values
        #Granted this means multiple passes through the files, but this is the only way to write
        #Code which doesn't look ugly and hardcoded. 
        #This is reusable in the other sections too.
        $bAAM = Set-AuditPolicy ${gptTmplPath} $global:DOM_CONTROLLERS_GUID "[Event Audit]" "AuditAccountManage" "3"
        $bADS = Set-AuditPolicy ${gptTmplPath} $global:DOM_CONTROLLERS_GUID "[Event Audit]" "AuditDSAccess" "3"

        if($bAAM -or $bADS)
        {
            $bDirty = $true
            Add-VersionCount ${iniFilePath} $global:DOM_CONTROLLERS_GUID
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Audit Policy updated..."
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Audit Policy already updated, not making changes..."
        }
    }
    else
    {
        $message = "Unable to find Sysvol share, cannot update Audit Policies..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
    }

    if($bDirty -eq $true)
    {
        $retVal = RunProcess "gpupdate" "/force"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "gpupdate returned ${retVal}"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done configuring Auditing in CORP..."
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Policies already updated, no changes required..."
    }

    #3. Update Registry
    Set-RegistryForSAMAccess

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Updating delegation, if the same step is re-run, the DS will notupdate the Security Descriptor..."
    Set-CorpDelegation
    
    Write-Divider
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "DC needs to reboot for changes to take effect. Please save your work and press enter..."
    Write-Divider
    Pause
    Restart-Computer -Force
}

function RunProcess
{
    param(
        [Parameter(Mandatory=$true)][string]$binary,
        [Parameter(Mandatory=$true)][string]$commandline,
        [Parameter(Mandatory=$false)][string]$showOutput
    )

    $retVal = $null

    $ps = new-object System.Diagnostics.Process
    $ps.StartInfo.FileName = $binary
    $ps.StartInfo.Arguments = $commandline
    $ps.StartInfo.UseShellExecute = $false
    $ps.StartInfo.RedirectStandardOutput = $true
    $ps.StartInfo.RedirectStandardError = $true
    $start = $ps.Start()
    $exited = $ps.WaitForExit()
    $retVal = $ps.ExitCode
    $out1 = ""
    $out2 = ""
    $suppress = $true
    if($showOutput -eq $true)
    {
        $suppress = $false
    }
    else
    {
        $suppress = $true
    }
    
    if($ps.StandardOutput -ne $null)
    {
        [string] $out1 = $ps.StandardOutput.ReadToEnd()
        if(-not [String]::IsNullOrEmpty($out1))
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $out1 -SuppressConsole $suppress
        }

    }
    if($ps.StandardError -ne $null)
    {
        [string] $out2 = $ps.StandardError.ReadToEnd()
        if(-not [String]::IsNullOrEmpty($out2))
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $out2 -SuppressConsole $suppress
        }
    }

    return $retVal
}

function Set-Delegation3
{
    param(
        [Parameter(Mandatory=$true)][Object]$users,
        [Parameter(Mandatory=$true)][string]$add
    )

    #Get the root DN. There are times when this fails, so we need to retry
    $retryCount = 0
    do
    {
        sleep 5 
        $configDN = (get-adrootdse).ConfigurationNamingContext
        $retryCount++
    } while( ([String]::IsNullOrEmpty($configDN) -eq $true) -and ($retryCount -lt 5))
    
    if([String]::IsNullOrEmpty($configDN) -eq $true)
    {
        $message = "Unable to get Configuration Naming Context, please retry after sometime"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "ConfigDN is ${configDN}"
    $shadowDN = "CN=Shadow Principal Configuration,CN=Services,${configDN}"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Shadow Principals DN is ${shadowDN}"
    $dnO = [ADSI]"LDAP://${shadowDN}"

    #First setup the common ones
    foreach($user in $users)
    {
        $userO = [Security.Principal.NTAccount]$user 
        
        #First Rule. ReadProperty, WriteProperty, Add Self as member
        $rule0 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
            [Security.Principal.IdentityReference]$userO,
            [DirectoryServices.ActiveDirectoryRights]'WriteProperty,CreateChild,DeleteChild',
            [Security.AccessControl.AccessControlType]'Allow',
            [Guid]'00000000-0000-0000-0000-000000000000',
            [DirectoryServices.ActiveDirectorySecurityInheritance]'All',
            [Guid]'00000000-0000-0000-0000-000000000000'
        )

        if($add -eq $true)
        {
            $dnO.ObjectSecurity.AddAccessRule($rule0);
        }
        else
        {
            $dnO.ObjectSecurity.RemoveAccessRule($rule0);
        }

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Updating ACLs for ${user}..."
        $dnO.CommitChanges();
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "ACLs for ${user} updated..."
    }
}

#
#For delegation we need to rely on the system to not update if
#the SAME ACE is passed in.
#
function Set-Delegation1
{
    param(
        [Parameter(Mandatory=$true)][Object]$users,
        [Parameter(Mandatory=$true)][string]$adminAccount,
        [Parameter(Mandatory=$true)][string]$add
    )

    #Get the root DN
    $dn = (get-adrootdse).defaultNamingContext
    $dnO = [ADSI]"LDAP://${dn}"

    #First setup the common ones
    foreach($user in $users)
    {
        $userO = [Security.Principal.NTAccount]$user 
        
        #First Rule. ReadProperty, WriteProperty, Add Self as member
        $rule0 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
            [Security.Principal.IdentityReference]$userO,
            [DirectoryServices.ActiveDirectoryRights]'ReadProperty,WriteProperty',
            [Security.AccessControl.AccessControlType]'Allow',
            [Guid]'bf9679c0-0de6-11d0-a285-00aa003049e2',
            [DirectoryServices.ActiveDirectorySecurityInheritance]'Descendents',
            [Guid]'bf967a9c-0de6-11d0-a285-00aa003049e2'
        )

        if($add -eq $true)
        {
            $dnO.ObjectSecurity.AddAccessRule($rule0)
        }
        else
        {
            $dnO.ObjectSecurity.RemoveAccessRule($rule0)
        }

        $rule1 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
            [Security.Principal.IdentityReference]$userO,
            [DirectoryServices.ActiveDirectoryRights]'CreateChild, DeleteChild',
            [Security.AccessControl.AccessControlType]'Allow',
            [Guid]'bf967aba-0de6-11d0-a285-00aa003049e2',
            [DirectoryServices.ActiveDirectorySecurityInheritance]'All',
            [Guid]'00000000-0000-0000-0000-000000000000'
         )
        if($add -eq $true)
        {
            $dnO.ObjectSecurity.AddAccessRule($rule1)
        }
        else
        {
            $dnO.ObjectSecurity.RemoveAccessRule($rule1)
        }

        $rule2 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
            [Security.Principal.IdentityReference]$userO,
            [DirectoryServices.ActiveDirectoryRights]'GenericAll',
            [Security.AccessControl.AccessControlType]'Allow',
            [Guid]'00000000-0000-0000-0000-000000000000',
            [DirectoryServices.ActiveDirectorySecurityInheritance]'Descendents',
            [Guid]'bf967aba-0de6-11d0-a285-00aa003049e2'
         )

        if($add -eq $true)
        {
            $dnO.ObjectSecurity.AddAccessRule($rule2)
        }
        else
        {
            $dnO.ObjectSecurity.RemoveAccessRule($rule2)
        }
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Updating ACLs for ${user}..."
        $dnO.CommitChanges();
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "ACLs for ${user} updated..."
    }


    #Now for the admin
    #We need to do three extended rights.
    #Change/Reset password on user
    #Migrate sid history for all
    $user1 = [Security.Principal.NTAccount]$adminAccount
    $rule1 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
        [Security.Principal.IdentityReference]$user1,
        [DirectoryServices.ActiveDirectoryRights]'ExtendedRight',
        [Security.AccessControl.AccessControlType]'Allow',
        [Guid]'00299570-246d-11d0-a768-00aa006e0529',
        [DirectoryServices.ActiveDirectorySecurityInheritance]'Descendents',
        [Guid]'bf967aba-0de6-11d0-a285-00aa003049e2'
    )
    if($add -eq $true)
    {
        $dnO.ObjectSecurity.AddAccessRule($rule1)
    }
    else
    {
        $dnO.ObjectSecurity.RemoveAccessRule($rule1)
    }
    
    $rule2 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
        [Security.Principal.IdentityReference]$user1,
        [DirectoryServices.ActiveDirectoryRights]'ExtendedRight',
        [Security.AccessControl.AccessControlType]'Allow',
        [Guid]'ab721a53-1e2f-11d0-9819-00aa0040529b',
        [DirectoryServices.ActiveDirectorySecurityInheritance]'Descendents',
        [Guid]'bf967aba-0de6-11d0-a285-00aa003049e2'
    )
    if($add -eq $true)
    {
        $dnO.ObjectSecurity.AddAccessRule($rule2)
    }
    else
    {
        $dnO.ObjectSecurity.RemoveAccessRule($rule2)
    }

    $rule3 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
        [Security.Principal.IdentityReference]$user1,
        [DirectoryServices.ActiveDirectoryRights]'ExtendedRight',
        [Security.AccessControl.AccessControlType]'Allow',
        [Guid]'ba33815a-4f93-4c76-87f3-57574bff8109',
        [DirectoryServices.ActiveDirectorySecurityInheritance]'All',
        [Guid]'00000000-0000-0000-0000-000000000000'
    )
    if($add -eq $true)
    {
        $dnO.ObjectSecurity.AddAccessRule($rule3)
    }
    else
    {
        $dnO.ObjectSecurity.RemoveAccessRule($rule3)
    }

    $rule4 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
        [Security.Principal.IdentityReference]$user1,
        [DirectoryServices.ActiveDirectoryRights]'CreateChild, DeleteChild',
        [Security.AccessControl.AccessControlType]'Allow',
        [Guid]'bf967a86-0de6-11d0-a285-00aa003049e2',
        [DirectoryServices.ActiveDirectorySecurityInheritance]'All',
        [Guid]'00000000-0000-0000-0000-000000000000'
    )
    if($add -eq $true)
    {
        $dnO.ObjectSecurity.AddAccessRule($rule4)
    }
    else
    {
        $dnO.ObjectSecurity.RemoveAccessRule($rule4)
    }

    $rule5 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
        [Security.Principal.IdentityReference]$user1,
        [DirectoryServices.ActiveDirectoryRights]'CreateChild, DeleteChild, ListChildren, ReadProperty, GenericWrite',
        [Security.AccessControl.AccessControlType]'Allow',
        [Guid]'00000000-0000-0000-0000-000000000000',
        [DirectoryServices.ActiveDirectorySecurityInheritance]'All',
        [Guid]'00000000-0000-0000-0000-000000000000'
    )
    if($add -eq $true)
    {
        $dnO.ObjectSecurity.AddAccessRule($rule5)
    }
    else
    {
        $dnO.ObjectSecurity.RemoveAccessRule($rule5)
    }

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Updating ACLs for ${adminAccount}..."
    $dnO.CommitChanges()
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "ACLs for ${adminAccount} updated..."
}

function Get-Password
{
    param(
        [Parameter(Mandatory=$true)][Object]$userType,
        [Parameter(Mandatory=$true)][string]$userName
    )
    
    $bFirst = $true
    Do
    {
        $error.Clear()
        if ($bFirst -eq $false)
        {  
            $SecurePassword = Read-Host "PASSWORDS DID NOT MATCH. Enter password for ${userType} ${userName}" -asSecureString  
            # write-host Breakpoint
        }
        else
        {
            $SecurePassword = Read-Host "Enter password for ${userType} ${userName}" -asSecureString  
            While ($SecurePassword.Length -eq 0)
            {
                $SecurePassword = Read-Host "A PASSWORD IS REQUIRED. Enter Password for ${userType} ${userName}:  " -asSecureString  
            }
            $bFirst = $false
        }
        if ($bFirst -eq $false)
        {
            $SecurePassword1 = Read-Host "Re-enter password for ${userType} ${userName}" -asSecureString  
            if ($SecurePassword1 -ne $null)
            {
                $bFirst = $false
                $BSTR = [System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($SecurePassword)
                $BSTR1 = [System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($SecurePassword1)
            }
        }                
    } Until (($bFirst -eq $false) -AND ([System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) -eq [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR1)))
    return $SecurePassword
}

function Set-Users
{
    param(
        [Parameter(Mandatory=$true)][string]$domain
    )
    $message = "Creating required users for ${domain} domain, if they don't exist" 
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    #First read them from the config XML file.
    #Let's create if they don't exist. 
    foreach($account in ($global:ADDSRole).Accounts.Account)
    {
        $accountName = $account.Name
        $accountType = $account.Type
        $accountDomain = $account.DomainRef

        if($domain.ToLowerInvariant().Equals($accountDomain.ToLowerInvariant()) -eq $false)
        {
            continue
        }

        $b = Confirm-ADAccountExists $accountName
        if($b -eq $false)
        {
            $description = "$accountType for ADDS Role"
            $message = "Creating new user ${accountName} in PRIV, ${description}" 
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
            #Let's get password first
            $pass = Get-Password $accountType $accountName
            new-aduser -name $accountName -samAccountName $accountName -DisplayName $accountName -Description $description -AccountPassword $pass
            set-aduser -identity $accountName -Enabled 1
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "$accountName already exists, not creating..."
        }
    }
    foreach($account in ($global:SQLRole).Accounts.Account)
    {
        $accountName = $account.Name
        $accountType = $account.Type
        $accountDomain = $account.DomainRef
        if($domain.ToLowerInvariant().Equals($accountDomain.ToLowerInvariant()) -eq $false)
        {
            continue
        }

        $b = Confirm-ADAccountExists $accountName
        if($b -eq $false)
        {
            $description = "$accountType for SQL Role"
            $message = "Creating new user ${accountName} in PRIV, ${description}" 
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
            #Let's get password first
            $pass = Get-Password $accountType $accountName
            new-aduser -name $accountName -samAccountName $accountName -DisplayName $accountName -Description $description -AccountPassword $pass
            set-aduser -identity $accountName -Enabled 1
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "$accountName already exists, not creating..."
        }
    }
    foreach($account in ($global:SPRole).Accounts.Account)
    {
        $accountName = $account.Name
        $accountType = $account.Type
        $accountDomain = $account.DomainRef
        if($domain.ToLowerInvariant().Equals($accountDomain.ToLowerInvariant()) -eq $false)
        {
            continue
        }

        $b = Confirm-ADAccountExists $accountName
        if($b -eq $false)
        {
            $description = "$accountType for Sharepoint Role"
            $message = "Creating new user ${accountName} in PRIV, ${description}" 
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
            #Let's get password first
            $pass = Get-Password $accountType $accountName
            new-aduser -name $accountName -samAccountName $accountName -DisplayName $accountName -Description $description -AccountPassword $pass
            set-aduser -identity $accountName -Enabled 1
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "$accountName already exists, not creating..."
        }
    }
    foreach($account in ($global:MIMRole).Accounts.Account)
    {
        $accountName = $account.Name
        $accountType = $account.Type
        $accountDomain = $account.DomainRef
        if($domain.ToLowerInvariant().Equals($accountDomain.ToLowerInvariant()) -eq $false)
        {
            continue
        }

        $b = Confirm-ADAccountExists $accountName
        if($b -eq $false)
        {
            $description = "$accountType for MIM Role"
            $message = "Creating new user ${accountName} in PRIV, ${description}" 
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
            #Let's get password first
            $pass = Get-Password $accountType $accountName
            new-aduser -name $accountName -samAccountName $accountName -DisplayName $accountName -Description $description -AccountPassword $pass
            set-aduser -identity $accountName -Enabled 1
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "$accountName already exists, not creating..."
        }
    }

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done checking required users for ${domain} domain"
}

function Set-PrivUsers 
{
    Set-Users "priv"
}

function Set-CorpUsers
{
    Set-Users "corp"
}

function Get-AccountForRole
{
    param(
        [Parameter(Mandatory=$true)][string]$roleName,
        [Parameter(Mandatory=$true)][string]$type
    )
    switch($roleName)
    {
        "ADDS" { $role = $Global:ADDSRole }
        "SQL" { $role = $Global:SQLRole }
        "SharePoint" { $role = $Global:SPRole }
        "MIM" { $role = $Global:MIMRole }
    }

    foreach($account in ($role).Accounts.Account)
    {
        if($account.Type.ToLowerInvariant().Equals($type.ToLowerInvariant()))
        {
            return $account.Name
        }
    }
    return $null
}


function Set-SPN
{
    $message = "Setting up SPN for Sharepoint & PAM REST API, if duplicate SPNs are found, SetSPN will abort"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message

    $sharepointSA = Get-AccountForRole "Sharepoint" "ServiceAccount"
    $mimSA = Get-AccountForRole "MIM" "ServiceAccount"
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $dnsName = Get-InnerValue $PrivDomain "DNSName"
    #TODO: If there are multiple machines this will have to be a loop
    $pamServer = $global:MIMRole.Machines.Machine.Name

    if($pamServer -eq $null)
    {
        $message = "Unable to find PAM Server in the config file, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }

    if($pamServer.ToLowerInvariant().Contains($dnsName.ToLowerInvariant()))
    {
        $index = $pamServer.IndexOf('.')
        $pamServer = $pamServer.Substring(0, $index)
    }

    if($sharepointSA -eq $null)
    {
        $message = "Unable to find Sharepoint Service Account, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }
    
    if($mimSA -eq $null)
    {
        $message = "Unable to find MIM Service Account, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
        throw $message
    }

    #We don't have to write code to check if the SPNs are already there
    #SetSPN will detect duplicate and will not update

    #setspn -S "http/${pamServer}.${dnsName}" "${netbiosName}\${sharepointSA}"
    #setspn -S "http/${pamServer}" "${netbiosName}\${sharepointSA}"
    #setspn -S "FIMService/${pamServer}.${dnsName}" "${netbiosName}\${mimSA}"
    #setspn -S "FIMService/${pamServer}" "${netbiosName}\${mimSA}"

    $retVal = RunProcess "setspn.exe" "-S `"http/${pamServer}.${dnsName}`" `"${netbiosName}\${sharepointSA}`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SetSPN returned ${retVal}"
    $retVal = RunProcess "setspn.exe" "-S `"http/${pamServer}`" `"${netbiosName}\${sharepointSA}`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SetSPN returned ${retVal}"
    $retVal = RunProcess "setspn.exe" "-S `"FIMService/${pamServer}.${dnsName}`" `"${netbiosName}\${mimSA}`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SetSPN returned ${retVal}"
    $retVal = RunProcess "setspn.exe" "-S `"FIMService/${pamServer}`" `"${netbiosName}\${mimSA}`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SetSPN returned ${retVal}"

    $message = "Done Setting up SPN for Sharepoint & PAM REST API"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
}

function Set-PrivAuditing
{
    #We go and edit the Default Domain Controllers Policy directly, but back it up first, in case we need to rollback
    #there is also DCGPOFix.exe, but that would restore the policy back to it was since the beginning of time
    #That should be fine for PRIV, but not for CORP.
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Configuring Auditing in PRIV..."

    $dnsName = Get-InnerValue $PrivDomain "DNSName"
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $userString = ""
    $monitor = Get-AccountForRole "MIM" "MonitorAccount"
    $service = Get-AccountForRole "MIM" "ServiceAccount"
    $component = Get-AccountForRole "MIM" "ComponentAccount"

    $userString = $monitor + ","  + $service + "," + $component
    $bDirty = $false
    $bSDBLR = $false
    $bSDRILR = $false
    $bAAM = $false
    $bADS = $false
    $bMTA = $false
    $bMSA = $false

    #First find location of sysvol
    $gpTmplPath = ""
    $iniFilePath = ""
    $smbShare = get-smbshare sysvol
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Finding the Sysvol share and the files..."
    if ($smbShare -ne $null)
    {
        #First set of changes are on the Domain Controllers Policy
        $gptTmplPath1 = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_CONTROLLERS_GUID\MACHINE\Microsoft\Windows NT\SecEdit\GptTmpl.inf"
        $iniFilePath1 = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_CONTROLLERS_GUID\GPT.INI"

        #$gptTmplPath = "c:\temp\test1.inf"
        #$iniFilePath =  "c:\temp\v1.ini"

        if(($gptTmplPath -eq $false) -or ($iniFilePath -eq $false))
        {
            $message = "Unable to find Sysvol share, cannot update Audit Policies..."
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
            throw $message
        }

        #Adjust the values
        #Granted this means multiple passes through the files, but this is the only way to write
        #Code which doesn't look ugly and hardcoded. 
        #This is reusable in the other sections too.
        $bAAM = Set-AuditPolicy ${gptTmplPath1} $global:DOM_CONTROLLERS_GUID "[Event Audit]" "AuditAccountManage" "3"
        $bADS = Set-AuditPolicy ${gptTmplPath1} $global:DOM_CONTROLLERS_GUID "[Event Audit]" "AuditDSAccess" "3"
        $bMTA = Set-AuditPolicy ${gptTmplPath1} $global:DOM_CONTROLLERS_GUID "[Kerberos Policy]" "MaxTicketage" "1"
        $bMSA = Set-AuditPolicy ${gptTmplPath1} $global:DOM_CONTROLLERS_GUID "[Kerberos Policy]" "MaxServiceAge" "60"
        if($bAAM -or $bADS -or $bMTA -or $bMSA)
        {
            $bDirty = $true
            Add-VersionCount ${iniFilePath1} $global:DOM_CONTROLLERS_GUID
        }

        #Second set of changes are on the Domain Policy
        $gptTmplPath2 = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_GUID\MACHINE\Microsoft\Windows NT\SecEdit\GptTmpl.inf"
        $iniFilePath2 = ${smbShare}.Path + "\${dnsName}\Policies\$global:DOM_GUID\GPT.INI"

        $bSDBLR = Set-AuditPolicy ${gptTmplPath2} $global:DOM_GUID "[Privilege Rights]" "SeDenyBatchLogonRight" $userString $true
        $bSDRILR = Set-AuditPolicy ${gptTmplPath2} $global:DOM_GUID "[Privilege Rights]" "SeDenyRemoteInteractiveLogonRight" $userString $true

        if($bSDBLR -or $bSDRILR)
        {
            $bDirty = $true
            Add-VersionCount ${iniFilePath2} $global:DOM_GUID
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Audit and Security Policies updated..."
        }
    }
    else
    {
        $message = "Unable to find Sysvol share, cannot update Audit Policies..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -message $message
    }

    if($bDirty -eq $true)
    {
        $retVal = RunProcess "gpupdate" "/force"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "gpupdate returned ${retVal}"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done configuring Auditing in PRIV..."
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Policies already updated, no changes required..."
    }
}

function Set-PrivDelegation
{
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $monitor = Get-AccountForRole "MIM" "MonitorAccount"
    $service = Get-AccountForRole "MIM" "ServiceAccount"
    $component = Get-AccountForRole "MIM" "ComponentAccount"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Configuring delegation in PRIV..."
    $adminUser = Get-AccountForRole "MIM" "AdminAccount"
    $qualifiedUsers = "${netbiosName}\${monitor}","${netbiosName}\${service}","${netbiosName}\${component}"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "The three users are:${qualifiedUsers}..."

    $qualifiedAdmin = "${netbiosName}\${adminUser}"
    $message = "Admin user is :${qualifiedAdmin}"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    Set-Delegation1 $qualifiedUsers $qualifiedAdmin $true
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done configuring delegation in PRIV..."
}

function Remove-PrivDelegation
{
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $monitor = Get-AccountForRole "MIM" "MonitorAccount"
    $service = Get-AccountForRole "MIM" "ServiceAccount"
    $component = Get-AccountForRole "MIM" "ComponentAccount"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Removing delegation in PRIV..."
    $adminUser = Get-AccountForRole "MIM" "AdminAccount"
    $qualifiedUsers = "${netbiosName}\${monitor}","${netbiosName}\${service}","${netbiosName}\${component}"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "The three users are:${qualifiedUsers}..."

    $qualifiedAdmin = "${netbiosName}\${adminUser}"
    $message = "Admin user is :${qualifiedAdmin}"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    Set-Delegation1 $qualifiedUsers $qualifiedAdmin $false
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done removing delegation in PRIV..."
}

#
#For delegation we need to rely on the system to not update if
#the SAME ACE is passed in.
#It is hard to check from powershell if an ACE is present.
#
function Set-Delegation2
{
    param(
        [Parameter(Mandatory=$true)][Object]$sids,
        [Parameter(Mandatory=$true)][boolean]$add
    )

    #Get the root DN
    $dn = (get-adrootdse).defaultNamingContext
    $dnO = [ADSI]"LDAP://${dn}"

    foreach($sid in $sids)
    {
        $operation = ""
        if($add -eq $true)
        {
            $operation = "Adding"
            $operation2 = "added"
        }
        else
        {
            $operation = "Removing"
            $operation2 = "removed"
        }

        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "${operation} delegation for Sid:${sid}"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "It will be a no-op if SID is already ${operation2}"
        $sidO = New-Object Security.Principal.SecurityIdentifier($sid)
        #ReadProperty for all users
        $rule0 = New-Object DirectoryServices.ActiveDirectoryAccessRule(
            [Security.Principal.IdentityReference]$sidO,
            [DirectoryServices.ActiveDirectoryRights]'ReadProperty',
            [Security.AccessControl.AccessControlType]'Allow',
            [Guid]'00000000-0000-0000-0000-000000000000',
            [DirectoryServices.ActiveDirectorySecurityInheritance]'Descendents',
            [Guid]'bf967aba-0de6-11d0-a285-00aa003049e2'
        )
        if($add -eq $true)
        {
            $dnO.ObjectSecurity.AddAccessRule($rule0);
        }
        else
        {
            $dnO.ObjectSecurity.RemoveAccessRule($rule0);
        }
    }
    $dnO.CommitChanges();
}

function Get-Domain
{
    param(
        [Parameter(Mandatory=$true)][string]$dnsName,
        [Parameter(Mandatory=$false)][PSCredential]$creds
    )

    $domain = $null

    #We need to first check if the RSAT tools are installed. If not we need to install them.
    CheckAndInstallRSATADTools

    if($creds -ne $null)
    {
        $domain = Get-ADDomain ${dnsName} -Credential $creds
    }
    else
    {
        $domain = Get-ADDomain ${dnsName} 
    }

    if($domain -eq $null)
    {
        $message = "Domain with DNS Name :${dnsName} cannot be found, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    return $domain
}

function Get-DomainAdminsGroup
{
    param(
        [Parameter(Mandatory=$true)][string]$dnsName,
        [Parameter(Mandatory=$false)][PSCredential]$creds
    )

    $domain = Get-Domain  $dnsName $creds
    #Let's pick the first replica
    $server = $domain.ReplicaDirectoryServers[0]
    $domainSid = $domain.DomainSID
    $groupSid = $domainSid.Value + "-512"
    $filter = "ObjectSid -eq '$groupSid'"
    if($creds -ne $null)
    {
        $g = (Get-ADGroup -Filter $filter -Credential $creds -Server $server)
    }
    else
    {
        $g = (Get-ADGroup -Filter $filter -Server $server)
    }

    return $g
}

function Get-Server
{
    param(
        [Parameter(Mandatory=$true)][string]$dnsName,
        [Parameter(Mandatory=$false)][PSCredential]$creds
    )

    $domain = Get-Domain $dnsName $creds
    return $domain.ReplicaDirectoryServers[0]
}

#
#We need to set Read properties for Domain Admins -- for localization, we look for the group with "512" sid.
#
function Set-CorpDelegationWorker
{
    param(
        [Parameter(Mandatory=$true)][boolean]$add
    )

    #Read the file and pass it into Set-Delegation2
    $sids = @()
    foreach($line in (get-content $sidPath))
    {
        $sids += $line
    }

    Set-Delegation2 $sids $add
}


function Set-CorpDelegation
{
   Set-CorpDelegationWorker $true 
}

function Remove-CorpDelegation
{
   Set-CorpDelegationWorker $false
}

function Add-UsersToDA
{
    param(
        [Parameter(Mandatory=$true)][string]$type
    )

    $rootObject = Get-RootObject $type
    $sharepointSA = Get-AccountForRole "Sharepoint" "ServiceAccount"
    $mimSA = Get-AccountForRole "MIM" "ServiceAccount"
    $dnsName = Get-InnerValue $rootObject "DNSName"
    #ToDo : Check if it it's already a member
    $sharepointO = $null
    $mimO = $null

    try
    {
        $sharepointO = Get-AdUser -Filter {samAccountName -eq $sharepointSA} -ErrorAction SilentlyContinue
    }
    catch
    {
    }
    try
    {
        $mimO = Get-AdUser -Filter {samAccountName -eq $mimSA} -ErrorAction SilentlyContinue
    }
    catch
    {
    }

    #Now we get the Domain Admins (SID : -512) group
    $g = Get-DomainAdminsGroup $dnsName
    if($g -eq $null)
    {
        $message = "Cannot find the Domain Admins group for ${dnsName}"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    $gName = ${g}.Name

    $currentMembers = get-adgroupmember $g

    if($sharepointO -eq $null)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "Cannot find Sharepoint Service Account...skipping addition to ${gName}"
    }
    else
    {
        $bFound = $false
        foreach($member in $currentMembers)
        {
            if($member.name -eq $sharepointSA)
            {
                $bFound = $true
                break;
            }
            
        }
        if($bFound)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Sharepoint Service Account ${sharepointSA} already a member of ${gName}, not adding again"
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Adding Sharepoint Service Account ${sharepointSA} to ${gName}"
            Add-ADGroupMember $g  -Members $sharePointO 
        }
    }

    if($mimO -eq $null)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message "Cannot find MIM Service Account...skipping addition to ${gName}"
    }
    else
    {
        $bFound = $false
        foreach($member in $currentMembers)
        {
            if($member.name -eq $mimSA)
            {
                $bFound = $true
                break;
            }
            
        }
        if($bFound)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "MIM Service Account ${mimSA} already a member of ${gName}, not adding again"
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Adding MIM Service Account ${mimSA} to ${gName}"
            Add-ADGroupMember $g  -Members $mimO
        }
    }
}

function SetWS2016Permissions
{
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $service = Get-AccountForRole "MIM" "ServiceAccount"
    $adminUser = Get-AccountForRole "MIM" "AdminAccount"
    $componentUser = Get-AccountForRole "MIM" "ComponentAccount"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Configuring delegation in PRIV..."
    $qualifiedUsers = "${netbiosName}\${service}","${netbiosName}\${adminUser}","${netbiosName}\${componentUser}"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "The users are:${qualifiedUsers}..."
    Set-Delegation3 $qualifiedUsers $true
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Done configuring WS2016 delegation in PRIV..."
}

function Get-ADForestFunctionalLevel
{
    param(
        [Parameter(Mandatory=$true)][string]$type
    )
    $rootObject = Get-RootObject $type
    $domainName = Get-InnerValue $PrivDomain "DNSName"
    $dc = Get-DomainController $rootObject $type
    if($dc -eq $null)
    {
        #This should never happen still
        $message = "Unable to find a domain controller, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
        throw
    }

    $hostNames = $dc.HostName
    $server = $null
    if($hostNames.Length -eq 0)
    {
        #This should never happen still
        $message = "Unable to find a host, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
        throw
    }
    else
    {
        $server = $hostNames[0]
    }

    $forest = get-adforest -Server $server
    if($forest -eq $null)
    {
        #This should never happen still
        $message = "Unable to find the forest, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
        throw
    }

    #We need to convert to int
    $currentFL = [System.Convert]::ToInt32(${forest}.ForestMode)
    return $currentFL
}

function WS2016AdditionalConfig
{
    #We want the administrators to be the one deciding about the functional levels.
    #If the FFL is not WS2016 in the PRIV forest, just warn and point to the documentation
    #If it is indeed WS2016, enable the feature, and change the delegation for 
    #mimadmin & mimservice to create child objects.
    $is2016OrHigher = Test-IsVersion2016OrHigher
    $domainName = Get-InnerValue $PrivDomain "DNSName"
    if($is2016OrHigher -eq $true)
    {
        $message = "Found a WS2016 Server, checking to see if additional configuration needs to be done..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
        $currentFL = Get-ADForestFunctionalLevel -Type "priv"
        if($currentFL -lt 7)
        {
            $message = "The Domain Controller is WS2016, but the Forest Functonal Level is less than WinThreshold, not performing additional configuration. Please re-run the script after raising the Forest FunctionalLevel to WinThreshold"
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        }
        else #Functional level is also 7, so let's enable the feature and do additional configuration
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Looking for the optional feature"
            $of = get-ADOptionalFeature -filter "name -eq 'privileged access management feature'" -ErrorAction SilentlyContinue
            if($of -eq $null)
            {
                $message = "Unable to find the feature..."
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message $message
                throw
            }

            #Now we check if the feature is enabled. If so, nothing to do.
            $enabledScopes = $of.EnabledScopes
            if(($enabledScopes -eq $null) -or ($enabledScopes.Count -eq 0))
            {
                
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Trying to enable AD Optional Feature ..."
                try
                {
                    Enable-ADOptionalFeature $of -scope ForestOrConfigurationSet -target "${domainName}"
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "AD Optional Feature enabled..."
                }
                catch
                {
                    $message = "Unable to enable the feature..."
                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message $message
                    throw
                }
            }
            else
            {
                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "AD Optional Feature already enabled..."
            }

            #Perform additional configuration of setting permissions
            SetWS2016Permissions
        }
    }
    else
    {
        $message = "Not a WS2016 Forest, no additional configuration done..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    }
}

function Test-IsVersion2016OrHigher
{
    $cim = Get-CimInstance Win32_OperatingSystem
    $retval = $false
    $arrVer = $cim.version.Split(".")
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "OS Version is $arrVer"
    # we should have an array of at least three elements
    # the [0] element contains the "major" version number
    # the [1] element contains the "minor" version number
    # the [2] element contains the build number
    # NB: Server and Workstation cannot be differentiated by this numbering scheme.
    If ($arrVer.Length -gt 1)
    {
        $major = $arrVer[0]
        If (([Int32]$major) -ge 10) #WS2016 is 10
        {
            $retval = $true
        }
    }
    return $retval
}

function SiloConfig
{
    #Let's get the configDN
    $configDN = (get-adrootdse).ConfigurationNamingContext
    $authPolicyDN= "`"CN=AuthN Policies,CN=AuthN Policy Configuration,CN=Services,${configDN}`""
    $authSiloDN= "`"CN=AuthN Silos,CN=AuthN Policy Configuration,CN=Services,${configDN}`""
    $adminUser = Get-AccountForRole "MIM" "AdminAccount"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Performing ACLing for AuthN Policy"
    
    $retVal = RunProcess "dsacls" "${authPolicyDN} /g `"${adminUser}:RPWPRCWD;;msDS-AuthNPolicy`" /i:s"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "dsacls returned ${retVal}"
    $retVal = RunProcess "dsacls" "${authPolicyDN} /g `"${adminUser}:CCDC;msDS-AuthNPolicy`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "dsacls returned ${retVal}"
    $retVal = RunProcess "dsacls" "${authSiloDN} /g `"${adminUser}:RPWPRCWD;;msDS-AuthNPolicySilo`" /i:s"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "dsacls returned ${retVal}"
    $retVal = RunProcess "dsacls" "${authSiloDN} /g `"${adminUser}:CCDC;msDS-AuthNPolicySilo`""
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "dsacls returned ${retVal}"

    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Completed ACLing for AuthN Policy"
}

function DumpSIDs
{
    #We are looking for PrivDomain here because we need to add the Priv Domain Users 
    #to the CORP domain
    $netbiosName = Get-InnerValue $PrivDomain "NetbiosName"
    $dnsName = Get-InnerValue $PrivDomain "DNSName"
    $adminUser = Get-AccountForRole "MIM" "AdminAccount"
    $monitor = Get-AccountForRole "MIM" "MonitorAccount"
    $users = $adminUser, $monitor

    #Before we do anything, let's make sure we can reach PRIV.
    $rootObject = Get-RootObject "priv"
    $domain = Get-DomainController $rootObject "priv"
    if($domain -eq $null)
    {
        $message = "PRIV Domain with DNS Name :${dnsName} cannot be found, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    #This needs getting SIDs for PRIV users, then calling the right ACL function
    #We don't need creds, we are already running as DA.
    $sids = @()

    $g = Get-DomainAdminsGroup $dnsName
    $sidVal = ${g}.SID.Value
    $sids += $sidVal

    $server = Get-Server $dnsName

    foreach($user in $users)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Trying to get the SID for ${user} from PRIV forest"
        $filter = "`samaccountname -eq `"${user}`""
        $u =  (Get-ADUser -Filter $filter -Server $server)
        if($u -eq $null)
        {
            $message = "Cannot find a user matching ${user}, the SID for this user is needed for configuring permissions in CORP forest"
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
            throw $message
        }

        $sidVal = ${u}.SID.Value
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "The SID for ${user} is ${sidVal}"
        $sids += $sidVal
    }

    #Now we write it into a text file
    foreach($sid in $sids)
    {
        Add-Content -Path $sidPath -Value $sid 
    }

    Write-divider
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Please copy SIDs.txt from $currentScriptLocation to the CORP DC's PAM folder before running Corp configuration"
    Write-divider
}

function Set-PrivConfigurationInternal
{
    $rootObject = Get-RootObject "priv"
    $domain = Get-DomainController $rootObject "priv"
    if($domain -eq $null)
    {
        $message = "Domain with DNS Name :${dnsName} cannot be found, exiting..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw $message
    }

    #Then we check the functional level
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Checking the Forest Functional level if it meets PAM requirements..."
    $currentFL = Get-ADForestFunctionalLevel -Type "priv"
    if($currentFL -lt 6)
    {
        $message = "The Forest Functonal Level is less than Win2012R2, PAM Requires Forest Functional Level to be Win2012R2 or higher, Please re-run the script after raising the Forest FunctionalLevel to Win2012R2 or higher..."
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Warning -Message $message
        throw
    }
    else
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Forest Functional level meets PAM requirements..."
    }

    $message = "Setting up configuration for PRIV"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message $message
    #There are 8 things we need to do
    #1. Create service accounts & users
    #2. Configure auditing and logon rights
    #3. Configure registry settings
    #4. Configure delegation
    #5. Set SPN -- TODO: the multiple-machine setup will need all registered
    #6. Add Sharepoint & MIM Service Accounts to 'Domain Admins'
    #7. If WS2016, additional configuration
    #8. SiloConfig

    #1. 
    Set-PrivUsers

    #2.Configure auditing
    Set-PrivAuditing

    #3. Update Registry
    #If it exists ignore
    Set-RegistryForSAMAccess

    #4 Configure delegation
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Updating delegation, if the same step is re-run, the DS will notupdate the Security Descriptor"
    Set-PrivDelegation

    #5 Setup SPN
    Set-SPN

    #6 Add users to Domain Admins
    Add-UsersToDA "priv"

    #If the forest is 2016, there is additional configuration to be done
    WS2016AdditionalConfig

    #Additional changes for SILO configuration
    SiloConfig

    #Dump SIDs for users into a text file, only if they don't already exist.
    if((Test-Path $sidPath) -eq $false)
    {
        DumpSIDs
    }

    Write-Divider
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "DC needs to reboot for changes to take effect. Please save your work and press enter..."
    Write-Divider
    Pause
    Restart-Computer -Force
}


function Set-TrustInternal
{
    if($global:PrivOnly -eq $true)
    {
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Priv Only, so no trust required..."
    }
    else
    {
        import-module mimpam
        $netbiosName = Get-InnerValue $CorpDomain "NetbiosName"
        $domainDNS = Get-InnerValue $CorpDomain "DNSName"
        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Getting CORP credentials to create the trust"
        $userName = Read-Host "Enter user name for creating Trust with CORP Forest:${netbiosName}\"
        $SecurePassword = Read-Host "Enter password for ${userName}" -asSecureString  
        $qualifiedUserName = "${netbiosName}\${userName}"
        $creds = new-object System.Management.Automation.PSCredential -ArgumentList $qualifiedUserName, $SecurePassword
        if((Test-PAMTrust -SourceForest ${domainDNS} -CorpCredentials $creds) -eq $false)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Executing New-PAMTrust command ..."
            New-PamTrust -SourceForest ${domainDNS} -Credentials $creds
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "New-PAMTrust command executed..."
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "PAMTrust already exists..."
        }

        if((Test-PAMDomainConfiguration -SourceDomain ${domainDNS} -Credentials $creds) -eq $false)
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Executing New-PAMDomainConfiguration command ..."
            New-PAMDomainConfiguration -SourceDomain ${netbiosName} -Credentials $creds
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "New-PAMDomainConfiguration command executed..."
        }
        else
        {
            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "PAMConfiguration already exists..."
        }
    }
}

function Set-CorpConfiguration
{
    Invoke-PAMSetupFunction -functionDisplayName $MyInvocation.MyCommand.Name -functionName "Set-CorpConfigurationInternal" -NextFunctionMessage "Please execute SQL installation script"
}

function Set-PrivConfiguration
{
    Invoke-PAMSetupFunction -functionDisplayName $MyInvocation.MyCommand.Name -functionName "Set-PrivConfigurationInternal" -NextFunctionMessage "Please run PAMDeployment.ps1 and select  (Corp Configuration) on the CorpDC"
}

function Set-Trust
{
    Invoke-PAMSetupFunction -functionDisplayName $MyInvocation.MyCommand.Name -functionName "Set-TrustInternal"
}

#Utilities for testing
function Set-DNSServer
{
    $ipv4 = Read-Host "Enter the IPV4 address of the DNS Server"
    netsh interface ipv4 add dnsserver "Ethernet" address="${ipv4}"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Added DNS Server IPV4 Address" 
    $ipv6 = Read-Host "Enter the IPV6 address of the DNS Server"
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Added DNS Server IPV4 Address" 
    netsh interface ipv6 add dnsserver "Ethernet" address="${ipv6}"
}

function Set-DNSForwarder
{
    param(
        [Parameter(Mandatory=$true)][string]$type
    )
    $rootObject = Get-RootObject $type
    $dnsName = Get-InnerValue $rootObject "DNSName"
    $ipv4 = Read-Host "Enter the IPV4 address of the DNS Server"
    #netsh interface ipv4 add dnsserver "Ethernet" address="${ipv4}"
    Add-DNSServerConditionalForwarderZone -name ${dnsName} -masterServers ${ipv4}
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Added DNS Server IPV4 Address" 
}

Function Request-SetDNSServer
{
    $title = "DNS Delegation"
    $message = "Do you want to set the DNS Server settings?"

    $yes = New-Object System.Management.Automation.Host.ChoiceDescription "&Yes", `
        "Sets the DNS Server."

    $no = New-Object System.Management.Automation.Host.ChoiceDescription "&No", `
        "Will not set DNS Server settings."

    $options = [System.Management.Automation.Host.ChoiceDescription[]]($yes, $no)

    $result = $host.ui.PromptForChoice($title, $message, $options, 0) 

    switch ($result)
        {
            0 
                {
                    #"You selected Yes."
                    Set-DNSServer
                }
        }
}

function Setup-SIDHistoryAndFiltering
{
    #We need to run netdom trust to check SID history/filtering
    $privDomain = $PrivDomain.DNSName
    $corpDomain = $CorpDomain.DNSName
    $retVal = RunProcess "netdom" "trust $corpDomain /quarantine:no /domain $privDomain" $true
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "netdom quarantine returned ${retVal}"
    $retVal = RunProcess "netdom" "trust $corpDomain /enablesidhistory:yes /domain $privDomain" $true
    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "netdom enablesidhistory returned ${retVal}"
}

Function MainMenu
{
    $newLine = "`n"
    $newLineTab = "`n`t"

    $message = $message + $newLine + "-----------------------------------------------------------------------"
    $message = $message + $newLine + "                Microsoft PAM Deployment Script                        "
    $message = $message + $newLine + "-----------------------------------------------------------------------"

    $message = $message + $newLineTab 

    $message = $message + $newLine + "PAM Deployment:"
    $message = $message + $newLineTab + "1) Priv Forest Configuration"
    $message = $message + $newLineTab + "2) Corp Forest Configuration"
    $message = $message + $newLineTab + "3) SQL Server Setup"
    $message = $message + $newLineTab + "4) SharePoint Setup"
    $message = $message + $newLineTab + "5) MIM PAM Setup"
    $message = $message + $newLineTab + "6) PAM Trust Setup"
    $message = $message + $newLineTab + "7) MIM PAM Client Setup"
    $message = $message + $newLineTab + "8) Setup SID history/SID filtering"
    $message = $message + $newLineTab 
    $message = $message + $newLine + "Optional Forest Setup:"
    $message = $message + $newLineTab + "9) Priv Forest Setup"
    $message = $message + $newLineTab + "10) Corp Forest Setup"
    $message = $message + $newLineTab 
    $message = $message + $newLineTab + "0) Exit"
    $message = $message + $newLineTab 
    Write-Host $message

    $selectMessage = "Select an option... [0-10]"

    $Global:selectOptionResult = Read-Host $selectMessage

    switch($selectOptionResult)
    {
        1 
            { 
                Write-Host "Priv Forest Configuration"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Set-PrivConfiguration
                break
            }
        2 
            { 
                Write-Host "Corp Forest Configuration"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Set-CorpConfiguration
                break
            }
        3 
            { 
                Write-Host "SQL Server Setup"
                $global:LogFileName = Get-LogFileName SQLSetup $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource

                Add-WindowsRole "RSAT-AD-PowerShell"
                Add-WindowsRole "Net-Framework-Features"

                Add-DomainJoin -domainName $PrivDomain.DNSName
    
                Install-SQLServer

                Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Please run PAMDeployment.ps1 and select (SharePoint Setup) after the server restarts to continue SharePoint installation."
    
                Set-Location $CurrentScriptLocation
                break
            }
        4 
            {
                Write-Host "SharePoint Setup"
                $global:LogFileName = Get-LogFileName SharePointSetup $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource

                Add-DomainJoin -domainName $PrivDomain.DNSName

                $spInstalled = Get-SharePointInstall
                If ($spInstalled)
                {
                    try
                    {
                        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  " - SharePoint 2013 appears to be already installed - skipping install."
     
                        AddPostSharePointFeatures

                        Set-Location $CurrentScriptLocation

                        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "SharePoint Installtion and Configuration completed."
        
                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Please run PAMDeployment.ps1 and select (MIM PAM Setup) after the server restarts to continue PAM installation."
                    }
                    catch
                    {
                        if ($error.Count -gt 0)
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message $_.Exception
                            throw
                        }
                    }

                } #Post install steps
                Else
                {
                
                    if (Test-Path -Path "$SharePointInstallRoot\sharepoint.exe")
                    {
                        if (Test-Path -Path "$SharePointInstallRoot\sp\setup.exe")
                        {
                            Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "SharePoint extracted files are exists"            
                        }
                        else
                        {
                            $SharePointExe = $SharePointInstallRoot + "\sharepoint.exe"
                            $SharePointExtractPath = $SharePointInstallRoot + "\sp"

                            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Executing $SharePointExe to extract install files to $SharePointExtractPath"
                            Set-Location $SharePointInstallRoot
                            Start-Process "sharepoint.exe" ArgumentList "/extract:.\SP /quiet" -wait   
                        }

                        if (Test-Path -Path "$SharePointInstallRoot\sp\setup.exe")
                        {
                            try
                            {
                                InstallSharePoint

                                #Going back to the current script location.
                                Set-Location $CurrentScriptLocation
                            } #Try
                            Catch
                            {
                                Write-Divider
                                $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message " - Script halted!"
                
                                If ($_.FullyQualifiedErrorId -ne $null -and $_.FullyQualifiedErrorId.StartsWith(" - "))
                                {
                                    # Error messages starting with " - " are thrown directly from this script
                                    $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message $_.FullyQualifiedErrorId
                                    if (IsRestartRequired)
                                    {
                                        Write-Divider
                                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Server needs to reboot. Please save your work and press enter..."
                                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Please rerun Sharepoint PAMDeployment.ps1 and select (Sharepoint Setup) after the reboot..."
                                        Write-Divider
                                        pause

                                        Restart-Computer -Force
                                    } #if restart required
                                } #if error message starts with -
                            } # Catch
                        } #Test for setup.exe
                        else
                        {
                            $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "SP2013 setup.exe not found. Please extract SharePoint by running SharePoint.exe"
                            pause
                        }
                    } #sharepoint.exe exists
                    else
                    {
                        $reply=Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message "sharepoint.exe not found in $SharePointInstallRoot"
                        pause
                    }
                }
                Set-Location $CurrentScriptLocation
                break
            }
        5 
            { 
                Write-Host "MIM PAM Setup"
                $global:LogFileName = Get-LogFileName MIMPAMSetup $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource

                ClearRestartRequired

                try
                {        

                    CheckFiles

                    PreparePAMServer-InstallRoles
    
                    Add-DomainJoin -domainName $PrivDomain.DNSName

                    UpdateLocalSecurityPolicy -xmlRoot $MIMRole

                    InstallMIMWithPAM

                    Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message  "Install completed"

                }
                catch
                {
                    if (IsRestartRequired)
                    {
                        Write-Divider
                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Information -Message "Server needs to reboot. Please save your work and press enter..."                    
                        Write-Divider
                        pause

                        Restart-Computer -Force
                    }
                    else
                    {
                        Write-divider
                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Script halted!"
                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "$_.Exception -  $_.ScriptStackTrace"
                        Write-LogsAndDisplay -EventID 1 -ErrorLevel Error -Message  "Please check the log file $LOGFILENAME"
                    }
                }

                break
            }
        6 
            { 
                Write-Host "PAM Trust Setup"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Set-Trust
                break
            }
        7 
            { 
                Write-Host "MIM PAM Client Setup"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Add-DomainJoin -domainName $CorpDomain.DNSName
                Set-Location $MIMPAMClientMSILOCATION
                Install-MIMPAMClient
                Set-Location $CurrentScriptLocation
                break
            }
        8
            {
                Write-Host "Setup SID history/SID filtering"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Setup-SIDHistoryAndFiltering 
                break
            }
        9
            { 
                Write-Host "Priv Forest Setup"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Install-FirstDomainController -type priv
                break
            }
        10 
            { 
                Write-Host "Corp Forest Setup"
                $global:LogFileName = Get-LogFileName MIMPAMInstall $installLogPath
                $res = Register-EventLogSource -eventLogName $EventLogName -eventLogSource $EventLogSource
                Install-FirstDomainController -type corp
                break
            }
        0 
            { 
                Write-Host "Exit" 
                Exit
            }
        default 
            { 
                Write-Host "Invalid option. Please select an option between 0 and 10:" -ForegroundColor Yellow
                return $false
            }
    }
    return $true
}

#Other modules set it, but since this if loaded first, it needs to be initialized here.

######################################
#     Parameters
######################################

$global:EventLogName = 'Application'
$global:EventLogSource = 'MIM-PAM Install'

$global:ADDSRole = $null
$global:SQLRole = $null
$global:SPRole = $null
$global:MIMRole = $null

$global:MimMonitor = $null
$global:MimService = $null
$global:MIMComponent = $null
$global:MimMonitorQualified = $null
$global:MimServiceQualified = $null
$global:MIMComponentQualified = $null

$global:DOM_CONTROLLERS_GUID = "{6AC1786C-016F-11D2-945F-00C04fB984F9}"
$global:DOM_GUID = "{31B2F340-016D-11D2-945F-00C04FB984F9}"

$CurrentScriptLocation= Convert-Path(Get-Location)
$CommonFunctions = "CommonFunctions.psm1"
$ADDSForestModule = "Initialize-ADDSForest.psm1"
$ConfigFileName = "PAMDeploymentConfig.xml"
$sidPath = "${currentScriptLocation}\Sids.txt"

$configFilePath = $CurrentScriptLocation + "\" + $ConfigFileName

#A way to install a test setup with DNS delegation included
$testSetup = $false

#Let's put the Log files in %AppData%\MIMPAMInstall
$installLogPath = "$ENV:AppData" + "\MIMPAMInstall"

if((Test-Path -Path $installLogPath) -eq $false)
{
    $logDirTemp = new-Item -ItemType directory -Path $installLogPath
}

Import-PAMDeployModule $CurrentScriptLocation $CommonFunctions
Import-PAMDeployModule $CurrentScriptLocation $ADDSForestModule

$Doc = New-Object System.Xml.XmlDocument
$Doc.Load($configfilePath)
$xmlRoot = $Doc

#Importing the XML configuration settings
Import-Settings $Doc

$SQLFolder = $Global:SQLRole.BinaryLocation.'#text'
$SharepointFolder = $Global:SPRole.BinaryLocation.'#text'

$SharePointInstallRoot="$SharepointFolder"
$SharePointInstallFolder=$SharePointInstallRoot + "\sp"
$SharePointPrerequisites = $Global:SPRole.PrerequisitesBinaryLocation.'#text'
$SharePoint2013Install = "$env:CommonProgramFiles\Microsoft Shared\Web Server Extensions\15\"

$Domain = $PrivDomain.NetbiosName
$DomainFQDN = $PrivDomain.DNSName

$webRole = "Web-WebServer"
$netFramework = "Net-Framework-Features"
$rsatAdPowerShell = "rsat-ad-powershell"
$webMgmtTools = "Web-Mgmt-Tools"
$applicationServer = "Application-Server"
$windowsIdentityFoundation = "Windows-Identity-Foundation"
$serverMedaionFoundation = "Server-Media-Foundation"
$xpsViewer = "Xps-Viewer"

$MIMRootFolder = $Global:MIMRole.BinaryLocation.'#text'

$MIMInstalledRoot = "$env:ProgramFiles\Microsoft Forefront Identity Manager\2010"
$PAMRestAPIFolder = "$MIMInstalledRoot\Privileged Access Management REST API"
$PAMRESTAPIfile = "$PAMRestAPIFolder\bin\Microsoft.IdentityManagement.PamRestApi.dll"
$PAMRestAPIWebConfig = "$PAMRestAPIFolder\Web.Config"
$PAMPortalFolder = "$MIMInstalledRoot\Privileged Access Management Portal"
$PAMPortalJSUtilsFile = "$PAMPortalFolder\js\utils.js"

$MIMPAMServerMSILOCATION = "$MIMRootFolder\Service and Portal"
$MIMPAMServerExecutableName = "Service and Portal"
$MIMPAMServerMSIFILENAME = "$MIMPAMServerExecutableName" + ".msi"

$MIMPAMClientMSILOCATION = $Global:MIMRole.ClientBinaryLocation.'#text'
$MIMPAMClientNameExecutableName = "Add-ins and extensions"
$MIMPAMClientMSIFILENAME = "$MIMPAMClientNameExecutableName" + ".msi"

$PAMPortalFolderName = "Privileged Access Management Portal"
$PAMPortalDirectory = "$MIMRootFolder\$PAMPortalFolderName"
$PAMDestinationDirectory = "$MIMInstalledRoot\$PAMPortalFolderName"
$FEATURES_TO_INSTALL="CommonServices,WebPortals,PAMServices"
$REBOOT="ReallySuppress"
$SQMOPTINSETTING=1
$ACCEPT_EULA=1
$FIREWALL_CONF=1
$SHAREPOINTUSERS_CONF=1
$PortalURL = $ServerName

$MIMPAM_REST_API_PORT=8086
$RestAPIResourceURL="$portalURL" + ":$MIMPAM_REST_API_PORT/api/pamresources/"
$PAMRESTAPISiteURL=$RestAPIResourceURL + "pamroles/"
$PAM_MONITORING_SERVICE_ACCOUNT_DOMAIN=$Domain
$PAM_COMPONENT_SERVICE_ACCOUNT_DOMAIN=$Domain
$PAM_SERVICE_ACCOUNT_DOMAIN=$Domain
$PAM_REST_API_APPPOOL_ACCOUNT_DOMAIN=$Domain
$OurRegistryLocation="PAM-MIM"
$global:RestartRegistryName="RestartIsRequired"

$ServerName = $MIMRole.Machines.Machine.Attributes["Name"].Value
$SQLSERVER_SERVER = $ServerName
$PAMportalURL="http://" + $ServerName + ":8090"
$SHAREPOINT_URL="http://$ServerName" +":82/"
$REGISTRATION_PORTAL_URL=""

do
{
    $menuResult = MainMenu
}while($menuResult -eq $false)
